function(BUILD_BISON OUTPUT DESTDIR SOURCES)
    set (_TMP_OUTPUT "")
    
    set (BISON_DEFENITIONS "")
    if (${PLATFORM_DIR} STREQUAL "WIN64")
        set (BISON_DEFENITIONS "-s ${TOOLS_DIR}/bison.simple")
    endif (${PLATFORM_DIR} STREQUAL "WIN64")

    foreach(_SOURCE ${SOURCES})
        get_filename_component (_TMP_FILE_PATH ${_SOURCE} PATH)
        set(_TMP_FILE_PATH ${DESTDIR}/${_TMP_FILE_PATH})
        get_filename_component (_TMP_FILE_NAME ${_SOURCE} NAME_WE)
        set (_TMP_BUILD_CPP_DEST "${_TMP_FILE_PATH}/${_TMP_FILE_NAME}_.tab.cpp")
        set (_TMP_BUILD_H_DEST "${OPENSG_DIR}/include/OpenSG/${_TMP_FILE_NAME}.tab.h")

        if (${PLATFORM_DIR} STREQUAL "WIN64")
            set (_TMP_BISON_HEADER "${_TMP_BUILD_CPP_DEST}.h")
        else (${PLATFORM_DIR} STREQUAL "WIN64")
            set (_TMP_BISON_HEADER "${_TMP_FILE_PATH}/${_TMP_FILE_NAME}_.tab.hpp")
        endif (${PLATFORM_DIR} STREQUAL "WIN64")

        list (APPEND _TMP_OUTPUT ${_TMP_BUILD_CPP_DEST})
        
        # The extra copying of a file is because bison names the header file to .cpp.h, and we simply make a copy with just .h
        add_custom_command (
            OUTPUT ${_TMP_BUILD_CPP_DEST} ${_TMP_BUILD_H_DEST}
            COMMAND ${CMAKE_COMMAND} -E make_directory "${_TMP_FILE_PATH}"
            COMMAND ${BISON_EXECUTABLE} -y -d -v -l -p ${_TMP_FILE_NAME}_ -o ${_TMP_BUILD_CPP_DEST} ${_SOURCE} ${BISON_DEFENITIONS}
            COMMAND ${CMAKE_COMMAND} -E copy ${_TMP_BISON_HEADER} ${_TMP_BUILD_H_DEST}
            DEPENDS ${_SOURCE}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

    endforeach(_SOURCE ${SOURCES})
    
    set (${OUTPUT} ${_TMP_OUTPUT} PARENT_SCOPE)
endfunction(BUILD_BISON)
