function(BUILD_FLEX OUTPUT DESTDIR SOURCES)
    set (_TMP_OUTPUT "")
    
    foreach(_SOURCE ${SOURCES})
        get_filename_component (_TMP_FILE_PATH ${_SOURCE} PATH)
        set(_TMP_FILE_PATH ${DESTDIR}/${_TMP_FILE_PATH})
        get_filename_component (_TMP_FILE_NAME ${_SOURCE} NAME_WE)
        set (_TMP_BUILD_CPP_DEST "${_TMP_FILE_PATH}/lex.${_TMP_FILE_NAME}_.t_cpp")
        set (_TMP_BUILD_CPP_DEST2 "${_TMP_FILE_PATH}/lex.${_TMP_FILE_NAME}_.cpp")

        list (APPEND _TMP_OUTPUT ${_TMP_BUILD_CPP_DEST2})
        add_custom_command (
            OUTPUT ${_TMP_BUILD_CPP_DEST2}
            COMMAND ${CMAKE_COMMAND} -E make_directory "${_TMP_FILE_PATH}"
            COMMAND ${FLEX_EXECUTABLE} -+ -P${_TMP_FILE_NAME}_ -o${_TMP_BUILD_CPP_DEST} ${_SOURCE}
            COMMAND ${CMAKE_COMMAND} -DLEX_FILEIN:STRING="${_TMP_BUILD_CPP_DEST}" -DLEX_FILEOUT:STRING="${_TMP_BUILD_CPP_DEST2}" -P "${OPENSG_ROOT}/CMake/includes/FixLex.cmake"
            DEPENDS ${_SOURCE}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
    endforeach(_SOURCE ${SOURCES})
    
    set (${OUTPUT} ${_TMP_OUTPUT} PARENT_SCOPE)
endfunction(BUILD_FLEX)
