
function(BUILD_SHADERS OUTPUT DESTDIR SOURCES)
    set (_TMP_OUTPUT "")
    set (_TMP_OUTPUT_HEADERS "")
    
    foreach(_SOURCE ${SOURCES})
        get_filename_component (_TMP_FILE_PATH ${_SOURCE} PATH)
        set(_TMP_FILE_PATH ${DESTDIR}/${_TMP_FILE_PATH})
        get_filename_component (_TMP_FILE_NAME ${_SOURCE} NAME)
        set (_TMP_BUILD_CPP_DEST "${_TMP_FILE_PATH}/${_TMP_FILE_NAME}.cpp")
        set (_TMP_BUILD_H_DEST "${OPENSG_DIR}/include/OpenSG/${_TMP_FILE_NAME}.h")
        
        list (APPEND _TMP_OUTPUT ${_TMP_BUILD_CPP_DEST})
        add_custom_command (
            OUTPUT ${_TMP_BUILD_CPP_DEST} ${_TMP_BUILD_H_DEST}
            COMMAND ${CMAKE_COMMAND} -E make_directory "${_TMP_FILE_PATH}"
            COMMAND ${PYTHON_EXECUTABLE} ${PIVR_ROOT}/vred/Source/Common/scripts/convertShaderToHeader.py ${_SOURCE} ${_TMP_BUILD_CPP_DEST} ${_TMP_BUILD_H_DEST} 1
            DEPENDS ${_SOURCE}
            WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
    endforeach(_SOURCE ${SOURCES})
    
    set (${OUTPUT} ${_TMP_OUTPUT} PARENT_SCOPE)
endfunction(BUILD_SHADERS)
