add_definitions ("-DWIN32" "-D_WINDOWS" "-D_WIN32_WINNT=0x0400" "-DWINVER=0x0400" "-D_WIN32_WINDOWS=0x0410" "-DWIN64" "-DCOMPILER_HAS_CPP0X" "-DNDEBUG" "-DSTRICT" "-DNOMINMAX")
add_definitions ("-DOSG_BUILD_DLL")

set (CCFLAGS /nologo /w44910 /w44258 /w44996 /bigobj /EHa /GR /Zm1200 /Zc:forScope /Gy /MD /Ox /GS- /MP)

set (LINK_FLAGS /nologo /incremental:no /NODEFAULTLIB /FORCE:MULTIPLE /OPT:REF /OPT:ICF)

set (LIBRARIES 
	"user32"
	"kernel32"
	"MSVCPRT"
	"MSVCRT"
	"winmm"
	"wsock32"
	"oldnames"
	"opengl32"
	"glu32"
)

# force_aspect
add_definitions ("-DOSG_FORCE_ASPECT")

# glut
add_definitions ("-DOSG_WITH_GLUT")
set (GLUT_DIR "${SOFTWARE_ROOT}/glut-3.7/${PLATFORM_DIR}")
include_directories("${GLUT_DIR}/include")
set (LIBRARIES ${LIBRARIES}  "${GLUT_DIR}/lib/glut32.lib")

# jpg
add_definitions ("-DOSG_WITH_JPG")
set (JPG_DIR "${SOFTWARE_ROOT}/jpeg-62/${PLATFORM_DIR}")
include_directories("${JPG_DIR}/include")
set (LIBRARIES ${LIBRARIES}  "${JPG_DIR}/lib/libjpeg.lib")

# tif
add_definitions ("-DOSG_WITH_TIF")
set (TIF_DIR "${SOFTWARE_ROOT}/tiff-3.57/${PLATFORM_DIR}")
include_directories("${TIF_DIR}/include")
set (LIBRARIES ${LIBRARIES}  "${TIF_DIR}/lib/tif32.lib")

# png
add_definitions ("-DOSG_WITH_PNG")
set (PNG_DIR "${SOFTWARE_ROOT}/png-1.25/${PLATFORM_DIR}")
include_directories("${PNG_DIR}/include")
set (LIBRARIES ${LIBRARIES}  "${PNG_DIR}/lib/libpng.lib")

# zlib (mandatory if png)
set (ZLIB_DIR "${SOFTWARE_ROOT}/zlib-1.14/${PLATFORM_DIR}")
include_directories("${ZLIB_DIR}/include")
set (LIBRARIES ${LIBRARIES}  "${ZLIB_DIR}/lib/zlib.lib")

# qt
set (QT_DIR "${SOFTWARE_ROOT}/qt-3.38-vc10.0/${PLATFORM_DIR}")
include_directories("${QT_DIR}/include")
file(GLOB _QT_LIBS "${QT_DIR}/lib/qt-mt*.lib")
set (LIBRARIES ${LIBRARIES}  ${_QT_LIBS})

# exr
add_definitions ("-DOSG_WITH_IMF" "-DOPENEXR_DLL")
set (EXR_DIR "${SOFTWARE_ROOT}/OpenEXR-2.1-vc10.0/${PLATFORM_DIR}")
include_directories("${EXR_DIR}/include" "${EXR_DIR}/include/OpenEXR")
file(GLOB _EXR_LIBS "${EXR_DIR}/lib/*.lib")
set (LIBRARIES ${LIBRARIES}  ${_EXR_LIBS})

# gif
add_definitions ("-DOSG_WITH_GIF")


include_directories ("${OPENSG_ROOT}/VSBuild/VS8")
include_directories ("${OPENSG_DIR}/include/OpenSG")

# Set the cmake default runtime output to OPENSG_DIR.
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY ${OPENSG_DIR})
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY_RELEASE ${OPENSG_DIR})
set (CMAKE_RUNTIME_OUTPUT_DIRECTORY_DEBUG ${OPENSG_DIR})

