/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *             Copyright (C) 2000-2002 by the OpenSG Forum                   *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

//---------------------------------------------------------------------------
//  Includes
//---------------------------------------------------------------------------

#include "OSGConfig.h"
#include <OSGFormat.h>

#include "OSGStringHelper.h"

OSG_BEGIN_NAMESPACE

// UInt8
std::string toString(const unsigned char &val)
{
    return fmt::FormatInt(val).str();
}

// Int8
std::string toString(const char &val)
{
    return fmt::FormatInt(val).str();
}

// UInt16
std::string toString(const unsigned short &val)
{
    return fmt::FormatInt(val).str();
}

// Int16
std::string toString(const short &val)
{
    return fmt::FormatInt(val).str();
}

// UInt32
std::string toString(const unsigned int &val)
{
    return fmt::FormatInt(val).str();
}

// Int32
std::string toString(const int &val)
{
    return fmt::FormatInt(val).str();
}

// UInt64
std::string toString(const unsigned long long &val)
{
    return fmt::FormatInt(val).str();
}

// Int64
std::string toString(const long long &val)
{
    return fmt::FormatInt(val).str();
}

// Real16
std::string toString(const Real16 &val)
{
    fmt::Writer w;
    w << float(val);
    return w.str();
}

// Real32
std::string toString(const float &val)
{
    fmt::Writer w;
    w << val;
    return w.str();
}

// Real64
std::string toString(const double &val)
{
    fmt::Writer w;
    w << val;
    return w.str();
}

// Real128
std::string toString(const long double &val)
{
    fmt::Writer w;
    w << val;
    return w.str();
}

OSG_END_NAMESPACE
