
#ifndef _OSGMINIZ_H
#define _OSGMINIZ_H

#include <OSGBase.h>

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

typedef unsigned long mz_ulong;

// Single-call compression functions mz_compress() and mz_compress2():
// Returns MZ_OK on success, or one of the error codes from mz_deflate() on failure.
OSG_BASE_DLLMAPPING int mz_compress(unsigned char *pDest, mz_ulong *pDest_len, const unsigned char *pSource, mz_ulong source_len);
OSG_BASE_DLLMAPPING int mz_compress2(unsigned char *pDest, mz_ulong *pDest_len, const unsigned char *pSource, mz_ulong source_len, int level);

// mz_compressBound() returns a (very) conservative upper bound on the amount of data that could be generated by calling mz_compress().
OSG_BASE_DLLMAPPING mz_ulong mz_compressBound(mz_ulong source_len);

// Single-call decompression.
// Returns MZ_OK on success, or one of the error codes from mz_inflate() on failure.
OSG_BASE_DLLMAPPING int mz_uncompress(unsigned char *pDest, mz_ulong *pDest_len, const unsigned char *pSource, mz_ulong source_len);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif
