#ifndef _IBIMPLEMENTATION_H_
#define _IBIMPLEMENTATION_H_
#pragma once

#include <OSGBase.h>
#include <OSGTime.h>
#include <OSGSocket.h>

OSG_BEGIN_NAMESPACE

class OSG_BASE_DLLMAPPING IBImplementation
{
  public:
    virtual ~IBImplementation(void)
    {
    }
    virtual void recv(void *buffer, size_t len) = 0;
    virtual void send(const void *buffer, size_t len) = 0;
    virtual bool waitReadable(Time timeout=-1) = 0;
    virtual int getAvailable(void) = 0;
    virtual void connect(StreamSocket socket) = 0;
    virtual void accept(StreamSocket socket) = 0;
    virtual void disconnect() = 0;
};

OSG_END_NAMESPACE

#endif /* _IBIMPLEMENTATION_H_ */
