/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *                 Copyright (C) 2011 by the OpenSG Forum                    *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/

#ifndef _OSGCONNECTIONHELPER_H_
#define _OSGCONNECTIONHELPER_H_

#include "OSGStreamSocket.h"
#include "OSGTime.h"

OSG_BEGIN_NAMESPACE

OSG_BASE_DLLMAPPING
bool connectSocket(StreamSocket      &socket,
                   const std::string &address,
                   SocketAddress     &destination,
                   Time               timeout     );

OSG_BASE_DLLMAPPING
bool acceptSocket(StreamSocket  &accept,
                  StreamSocket  &socket,
                  SocketAddress &destination,
                  Time           timeout     );

OSG_BASE_DLLMAPPING
UInt16 portFromString(const std::string &str);

OSG_END_NAMESPACE

#endif /* _OSGCONNECTIONHELPER_H_ */
