/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class Character
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#ifndef _OSGCHARACTERBASE_H_
#define _OSGCHARACTERBASE_H_
#pragma once


#include <OSGConfig.h>
#include <OSGContribDef.h>

#include <OSGBaseTypes.h>
#include <OSGRefPtr.h>
#include <OSGCoredNodePtr.h>

#include <OSGDrawable.h> // Parent

#include <OSGCharacterModelFields.h> // Model type
#include <OSGUInt32Fields.h> // CurrentAnimation type
#include <OSGReal32Fields.h> // BlendTime type
#include <OSGReal32Fields.h> // Delta type
#include <OSGReal32Fields.h> // TimeScale type
#include <OSGBoolFields.h> // DrawSkeleton type
#include <OSGBoolFields.h> // UseShaderForGeometry type
#include <OSGDynamicVolumeFields.h> // ModelVolume type

#include <OSGCharacterFields.h>

OSG_BEGIN_NAMESPACE

class Character;
class BinaryDataHandler;

//! \brief Character Base Class.

class OSG_CONTRIBLIB_DLLMAPPING CharacterBase : public Drawable
{
  private:

    typedef Drawable    Inherited;

    /*==========================  PUBLIC  =================================*/
  public:

    typedef CharacterPtr  Ptr;

    enum
    {
        ModelFieldId                = Inherited::NextFieldId,
        CurrentAnimationFieldId     = ModelFieldId                + 1,
        BlendTimeFieldId            = CurrentAnimationFieldId     + 1,
        DeltaFieldId                = BlendTimeFieldId            + 1,
        TimeScaleFieldId            = DeltaFieldId                + 1,
        DrawSkeletonFieldId         = TimeScaleFieldId            + 1,
        UseShaderForGeometryFieldId = DrawSkeletonFieldId         + 1,
        ModelVolumeFieldId          = UseShaderForGeometryFieldId + 1,
        NextFieldId                 = ModelVolumeFieldId          + 1
    };

    static const OSG::BitVector ModelFieldMask;
    static const OSG::BitVector CurrentAnimationFieldMask;
    static const OSG::BitVector BlendTimeFieldMask;
    static const OSG::BitVector DeltaFieldMask;
    static const OSG::BitVector TimeScaleFieldMask;
    static const OSG::BitVector DrawSkeletonFieldMask;
    static const OSG::BitVector UseShaderForGeometryFieldMask;
    static const OSG::BitVector ModelVolumeFieldMask;


    static const OSG::BitVector MTInfluenceMask;

    /*---------------------------------------------------------------------*/
    /*! \name                    Class Get                                 */
    /*! \{                                                                 */

    static        FieldContainerType &getClassType    (void); 
    static        UInt32              getClassTypeId  (void); 

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                FieldContainer Get                            */
    /*! \{                                                                 */

    virtual       FieldContainerType &getType  (void); 
    virtual const FieldContainerType &getType  (void) const; 

    virtual       UInt32              getContainerSize(void) const;

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                    Field Get                                 */
    /*! \{                                                                 */


           SFCharacterModelPtr *editSFModel          (void);
     const SFCharacterModelPtr *getSFModel          (void) const;
#ifndef OSG_2_PREP
           SFCharacterModelPtr *getSFModel          (void);
#endif

           SFUInt32            *editSFCurrentAnimation(void);
     const SFUInt32            *getSFCurrentAnimation(void) const;
#ifndef OSG_2_PREP
           SFUInt32            *getSFCurrentAnimation(void);
#endif

           SFReal32            *editSFBlendTime      (void);
     const SFReal32            *getSFBlendTime      (void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFBlendTime      (void);
#endif

           SFReal32            *editSFDelta          (void);
     const SFReal32            *getSFDelta          (void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFDelta          (void);
#endif

           SFReal32            *editSFTimeScale      (void);
     const SFReal32            *getSFTimeScale      (void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFTimeScale      (void);
#endif

           SFBool              *editSFDrawSkeleton   (void);
     const SFBool              *getSFDrawSkeleton   (void) const;
#ifndef OSG_2_PREP
           SFBool              *getSFDrawSkeleton   (void);
#endif

           SFBool              *editSFUseShaderForGeometry(void);
     const SFBool              *getSFUseShaderForGeometry(void) const;
#ifndef OSG_2_PREP
           SFBool              *getSFUseShaderForGeometry(void);
#endif

           SFDynamicVolume     *editSFModelVolume    (void);
     const SFDynamicVolume     *getSFModelVolume    (void) const;
#ifndef OSG_2_PREP
           SFDynamicVolume     *getSFModelVolume    (void);
#endif


           CharacterModelPtr   &editModel          (void);
     const CharacterModelPtr   &getModel          (void) const;
#ifndef OSG_2_PREP
           CharacterModelPtr   &getModel          (void);
#endif

           UInt32              &editCurrentAnimation(void);
     const UInt32              &getCurrentAnimation(void) const;
#ifndef OSG_2_PREP
           UInt32              &getCurrentAnimation(void);
#endif

           Real32              &editBlendTime      (void);
     const Real32              &getBlendTime      (void) const;
#ifndef OSG_2_PREP
           Real32              &getBlendTime      (void);
#endif

           Real32              &editDelta          (void);
     const Real32              &getDelta          (void) const;
#ifndef OSG_2_PREP
           Real32              &getDelta          (void);
#endif

           Real32              &editTimeScale      (void);
     const Real32              &getTimeScale      (void) const;
#ifndef OSG_2_PREP
           Real32              &getTimeScale      (void);
#endif

           bool                &editDrawSkeleton   (void);
     const bool                &getDrawSkeleton   (void) const;
#ifndef OSG_2_PREP
           bool                &getDrawSkeleton   (void);
#endif

           bool                &editUseShaderForGeometry(void);
     const bool                &getUseShaderForGeometry(void) const;
#ifndef OSG_2_PREP
           bool                &getUseShaderForGeometry(void);
#endif

           DynamicVolume       &editModelVolume    (void);
     const DynamicVolume       &getModelVolume    (void) const;
#ifndef OSG_2_PREP
           DynamicVolume       &getModelVolume    (void);
#endif

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                    Field Set                                 */
    /*! \{                                                                 */

     void setModel          ( const CharacterModelPtr &value );
     void setCurrentAnimation( const UInt32 &value );
     void setBlendTime      ( const Real32 &value );
     void setDelta          ( const Real32 &value );
     void setTimeScale      ( const Real32 &value );
     void setDrawSkeleton   ( const bool &value );
     void setUseShaderForGeometry( const bool &value );
     void setModelVolume    ( const DynamicVolume &value );

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                       Sync                                   */
    /*! \{                                                                 */

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Binary Access                              */
    /*! \{                                                                 */

    virtual SizeT  getBinSize (const BitVector         &whichField);
    virtual void   copyToBin  (      BinaryDataHandler &pMem,
                               const BitVector         &whichField);
    virtual void   copyFromBin(      BinaryDataHandler &pMem,
                               const BitVector         &whichField);


    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Construction                               */
    /*! \{                                                                 */

    static  CharacterPtr      create          (void); 
    static  CharacterPtr      createEmpty     (void); 

    /*! \}                                                                 */

    /*---------------------------------------------------------------------*/
    /*! \name                       Copy                                   */
    /*! \{                                                                 */

    virtual FieldContainerPtr     shallowCopy     (void) const; 

    /*! \}                                                                 */
    /*=========================  PROTECTED  ===============================*/
  protected:

    /*---------------------------------------------------------------------*/
    /*! \name                      Fields                                  */
    /*! \{                                                                 */

    SFCharacterModelPtr   _sfModel;
    SFUInt32            _sfCurrentAnimation;
    SFReal32            _sfBlendTime;
    SFReal32            _sfDelta;
    SFReal32            _sfTimeScale;
    SFBool              _sfDrawSkeleton;
    SFBool              _sfUseShaderForGeometry;
    SFDynamicVolume     _sfModelVolume;

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Constructors                               */
    /*! \{                                                                 */

    CharacterBase(void);
    CharacterBase(const CharacterBase &source);

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Destructors                                */
    /*! \{                                                                 */

    virtual ~CharacterBase(void); 

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                       Sync                                   */
    /*! \{                                                                 */

#if !defined(OSG_FIXED_MFIELDSYNC)
    void executeSyncImpl(      CharacterBase *pOther,
                         const BitVector         &whichField);

    virtual void   executeSync(      FieldContainer    &other,
                               const BitVector         &whichField);
#else
    void executeSyncImpl(      CharacterBase *pOther,
                         const BitVector         &whichField,
                         const SyncInfo          &sInfo     );

    virtual void   executeSync(      FieldContainer    &other,
                               const BitVector         &whichField,
                               const SyncInfo          &sInfo);

    virtual void execBeginEdit     (const BitVector &whichField,
                                          UInt32     uiAspect,
                                          UInt32     uiContainerSize);

            void execBeginEditImpl (const BitVector &whichField,
                                          UInt32     uiAspect,
                                          UInt32     uiContainerSize);

    virtual void onDestroyAspect(UInt32 uiId, UInt32 uiAspect);
#endif

    /*! \}                                                                 */
    /*==========================  PRIVATE  ================================*/
  private:

    friend class FieldContainer;

    static FieldDescription   *_desc[];
    static FieldContainerType  _type;


    // prohibit default functions (move to 'public' if you need one)
    void operator =(const CharacterBase &source);
};

//---------------------------------------------------------------------------
//   Exported Types
//---------------------------------------------------------------------------


typedef CharacterBase *CharacterBaseP;

typedef osgIF<CharacterBase::isNodeCore,
              CoredNodePtr<Character>,
              FieldContainer::attempt_to_create_CoredNodePtr_on_non_NodeCore_FC
              >::_IRet CharacterNodePtr;

typedef RefPtr<CharacterPtr> CharacterRefPtr;

OSG_END_NAMESPACE

#define OSGCHARACTERBASE_HEADER_CVSID "@(#)$Id: FCBaseTemplate_h.h,v 1.42 2008/06/09 12:26:59 vossg Exp $"

#endif /* _OSGCHARACTERBASE_H_ */
