/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class ShaderChunk
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#ifndef _OSGSHADERCHUNKBASE_H_
#define _OSGSHADERCHUNKBASE_H_
#pragma once


#include <OSGConfig.h>
#include <OSGSystemDef.h>

#include <OSGBaseTypes.h>
#include <OSGRefPtr.h>
#include <OSGCoredNodePtr.h>

#include <OSGShaderParameterChunk.h> // Parent

#include <OSGStringFields.h> // VertexProgram type
#include <OSGStringFields.h> // FragmentProgram type
#include <OSGStringFields.h> // GeometryProgram type

#include <OSGShaderChunkFields.h>

OSG_BEGIN_NAMESPACE

class ShaderChunk;
class BinaryDataHandler;

//! \brief ShaderChunk Base Class.

class OSG_SYSTEMLIB_DLLMAPPING ShaderChunkBase : public ShaderParameterChunk
{
  private:

    typedef ShaderParameterChunk    Inherited;

    /*==========================  PUBLIC  =================================*/
  public:

    typedef ShaderChunkPtr  Ptr;

    enum
    {
        VertexProgramFieldId   = Inherited::NextFieldId,
        FragmentProgramFieldId = VertexProgramFieldId   + 1,
        GeometryProgramFieldId = FragmentProgramFieldId + 1,
        NextFieldId            = GeometryProgramFieldId + 1
    };

    static const OSG::BitVector VertexProgramFieldMask;
    static const OSG::BitVector FragmentProgramFieldMask;
    static const OSG::BitVector GeometryProgramFieldMask;


    static const OSG::BitVector MTInfluenceMask;

    /*---------------------------------------------------------------------*/
    /*! \name                    Class Get                                 */
    /*! \{                                                                 */

    static        FieldContainerType &getClassType    (void); 
    static        UInt32              getClassTypeId  (void); 

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                FieldContainer Get                            */
    /*! \{                                                                 */

    virtual       FieldContainerType &getType  (void); 
    virtual const FieldContainerType &getType  (void) const; 

    virtual       UInt32              getContainerSize(void) const;

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                    Field Get                                 */
    /*! \{                                                                 */


           SFString            *editSFVertexProgram  (void);
     const SFString            *getSFVertexProgram  (void) const;
#ifndef OSG_2_PREP
           SFString            *getSFVertexProgram  (void);
#endif

           SFString            *editSFFragmentProgram(void);
     const SFString            *getSFFragmentProgram(void) const;
#ifndef OSG_2_PREP
           SFString            *getSFFragmentProgram(void);
#endif

           SFString            *editSFGeometryProgram(void);
     const SFString            *getSFGeometryProgram(void) const;
#ifndef OSG_2_PREP
           SFString            *getSFGeometryProgram(void);
#endif


           std::string         &editVertexProgram  (void);
     const std::string         &getVertexProgram  (void) const;
#ifndef OSG_2_PREP
           std::string         &getVertexProgram  (void);
#endif

           std::string         &editFragmentProgram(void);
     const std::string         &getFragmentProgram(void) const;
#ifndef OSG_2_PREP
           std::string         &getFragmentProgram(void);
#endif

           std::string         &editGeometryProgram(void);
     const std::string         &getGeometryProgram(void) const;
#ifndef OSG_2_PREP
           std::string         &getGeometryProgram(void);
#endif

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                    Field Set                                 */
    /*! \{                                                                 */

     void setVertexProgram  ( const std::string &value );
     void setFragmentProgram( const std::string &value );
     void setGeometryProgram( const std::string &value );

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                       Sync                                   */
    /*! \{                                                                 */

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Binary Access                              */
    /*! \{                                                                 */

    virtual SizeT  getBinSize (const BitVector         &whichField);
    virtual void   copyToBin  (      BinaryDataHandler &pMem,
                               const BitVector         &whichField);
    virtual void   copyFromBin(      BinaryDataHandler &pMem,
                               const BitVector         &whichField);


    /*! \}                                                                 */
    /*=========================  PROTECTED  ===============================*/
  protected:

    /*---------------------------------------------------------------------*/
    /*! \name                      Fields                                  */
    /*! \{                                                                 */

    SFString            _sfVertexProgram;
    SFString            _sfFragmentProgram;
    SFString            _sfGeometryProgram;

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Constructors                               */
    /*! \{                                                                 */

    ShaderChunkBase(void);
    ShaderChunkBase(const ShaderChunkBase &source);

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Destructors                                */
    /*! \{                                                                 */

    virtual ~ShaderChunkBase(void); 

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                       Sync                                   */
    /*! \{                                                                 */

#if !defined(OSG_FIXED_MFIELDSYNC)
    void executeSyncImpl(      ShaderChunkBase *pOther,
                         const BitVector         &whichField);

    virtual void   executeSync(      FieldContainer    &other,
                               const BitVector         &whichField);
#else
    void executeSyncImpl(      ShaderChunkBase *pOther,
                         const BitVector         &whichField,
                         const SyncInfo          &sInfo     );

    virtual void   executeSync(      FieldContainer    &other,
                               const BitVector         &whichField,
                               const SyncInfo          &sInfo);

    virtual void execBeginEdit     (const BitVector &whichField,
                                          UInt32     uiAspect,
                                          UInt32     uiContainerSize);

            void execBeginEditImpl (const BitVector &whichField,
                                          UInt32     uiAspect,
                                          UInt32     uiContainerSize);

    virtual void onDestroyAspect(UInt32 uiId, UInt32 uiAspect);
#endif

    /*! \}                                                                 */
    /*==========================  PRIVATE  ================================*/
  private:

    friend class FieldContainer;

    static FieldDescription   *_desc[];
    static FieldContainerType  _type;


    // prohibit default functions (move to 'public' if you need one)
    void operator =(const ShaderChunkBase &source);
};

//---------------------------------------------------------------------------
//   Exported Types
//---------------------------------------------------------------------------


typedef ShaderChunkBase *ShaderChunkBaseP;

typedef osgIF<ShaderChunkBase::isNodeCore,
              CoredNodePtr<ShaderChunk>,
              FieldContainer::attempt_to_create_CoredNodePtr_on_non_NodeCore_FC
              >::_IRet ShaderChunkNodePtr;

typedef RefPtr<ShaderChunkPtr> ShaderChunkRefPtr;

OSG_END_NAMESPACE

#define OSGSHADERCHUNKBASE_HEADER_CVSID "@(#)$Id: FCBaseTemplate_h.h,v 1.42 2008/06/09 12:26:59 vossg Exp $"

#endif /* _OSGSHADERCHUNKBASE_H_ */
