/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class Name!
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#define OSG_COMPILENAMEINST

#include <stdlib.h>
#include <stdio.h>

#include <OSGConfig.h>

#include "OSGNameBase.h"
#include "OSGName.h"


OSG_BEGIN_NAMESPACE

const OSG::BitVector  NameBase::NameFieldMask = 
    (TypeTraits<BitVector>::One << NameBase::NameFieldId);

const OSG::BitVector  NameBase::EncodingFieldMask = 
    (TypeTraits<BitVector>::One << NameBase::EncodingFieldId);

const OSG::BitVector NameBase::MTInfluenceMask = 
    (Inherited::MTInfluenceMask) | 
    (static_cast<BitVector>(0x0) << Inherited::NextFieldId); 


// Field descriptions

/*! \var std::string     NameBase::_sfName
    
*/
/*! \var UInt32          NameBase::_sfEncoding
    0 = latin1 or unknown 1 = utf8
*/

//! Name description

FieldDescription *NameBase::_desc[] = 
{
    new FieldDescription(SFString::getClassType(), 
                     "name", 
                     NameFieldId, NameFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&NameBase::editSFName)),
    new FieldDescription(SFUInt32::getClassType(), 
                     "encoding", 
                     EncodingFieldId, EncodingFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&NameBase::editSFEncoding))
};


FieldContainerType NameBase::_type(
    "Name",
    "Attachment",
    NULL,
    reinterpret_cast<PrototypeCreateF>(&NameBase::createEmpty),
    Name::initMethod,
    _desc,
    sizeof(_desc));

//OSG_FIELD_CONTAINER_DEF(NameBase, NamePtr)

/*------------------------------ get -----------------------------------*/

FieldContainerType &NameBase::getType(void) 
{
    return _type; 
} 

const FieldContainerType &NameBase::getType(void) const 
{
    return _type;
} 


FieldContainerPtr NameBase::shallowCopy(void) const 
{ 
    NamePtr returnValue; 

    newPtr(returnValue, dynamic_cast<const Name *>(this)); 

    return returnValue; 
}

UInt32 NameBase::getContainerSize(void) const 
{ 
    return sizeof(Name); 
}


#if !defined(OSG_FIXED_MFIELDSYNC)
void NameBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField)
{
    this->executeSyncImpl(static_cast<NameBase *>(&other),
                          whichField);
}
#else
void NameBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField,                                    const SyncInfo       &sInfo     )
{
    this->executeSyncImpl((NameBase *) &other, whichField, sInfo);
}
void NameBase::execBeginEdit(const BitVector &whichField, 
                                            UInt32     uiAspect,
                                            UInt32     uiContainerSize) 
{
    this->execBeginEditImpl(whichField, uiAspect, uiContainerSize);
}

void NameBase::onDestroyAspect(UInt32 uiId, UInt32 uiAspect)
{
    Inherited::onDestroyAspect(uiId, uiAspect);

}
#endif

/*------------------------- constructors ----------------------------------*/

#ifdef OSG_WIN32_ICL
#pragma warning (disable : 383)
#endif

NameBase::NameBase(void) :
    _sfName                   (), 
    _sfEncoding               (UInt32(0)), 
    Inherited() 
{
}

#ifdef OSG_WIN32_ICL
#pragma warning (default : 383)
#endif

NameBase::NameBase(const NameBase &source) :
    _sfName                   (source._sfName                   ), 
    _sfEncoding               (source._sfEncoding               ), 
    Inherited                 (source)
{
}

/*-------------------------- destructors ----------------------------------*/

NameBase::~NameBase(void)
{
}

/*------------------------------ access -----------------------------------*/

SizeT  NameBase::getBinSize(const BitVector &whichField)
{
    SizeT returnValue = Inherited::getBinSize(whichField);

    if(FieldBits::NoField != (NameFieldMask & whichField))
    {
        returnValue += _sfName.getBinSize();
    }

    if(FieldBits::NoField != (EncodingFieldMask & whichField))
    {
        returnValue += _sfEncoding.getBinSize();
    }


    return returnValue;
}

void NameBase::copyToBin(      BinaryDataHandler &pMem,
                                  const BitVector         &whichField)
{
    Inherited::copyToBin(pMem, whichField);

    if(FieldBits::NoField != (NameFieldMask & whichField))
    {
        _sfName.copyToBin(pMem);
    }

    if(FieldBits::NoField != (EncodingFieldMask & whichField))
    {
        _sfEncoding.copyToBin(pMem);
    }


}

void NameBase::copyFromBin(      BinaryDataHandler &pMem,
                                    const BitVector    &whichField)
{
    Inherited::copyFromBin(pMem, whichField);

    if(FieldBits::NoField != (NameFieldMask & whichField))
    {
        _sfName.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (EncodingFieldMask & whichField))
    {
        _sfEncoding.copyFromBin(pMem);
    }


}

#if !defined(OSG_FIXED_MFIELDSYNC)
void NameBase::executeSyncImpl(      NameBase *pOther,
                                        const BitVector         &whichField)
{

    Inherited::executeSyncImpl(pOther, whichField);

    if(FieldBits::NoField != (NameFieldMask & whichField))
        _sfName.syncWith(pOther->_sfName);

    if(FieldBits::NoField != (EncodingFieldMask & whichField))
        _sfEncoding.syncWith(pOther->_sfEncoding);


}
#else
void NameBase::executeSyncImpl(      NameBase *pOther,
                                        const BitVector         &whichField,
                                        const SyncInfo          &sInfo      )
{

    Inherited::executeSyncImpl(pOther, whichField, sInfo);

    if(FieldBits::NoField != (NameFieldMask & whichField))
        _sfName.syncWith(pOther->_sfName);

    if(FieldBits::NoField != (EncodingFieldMask & whichField))
        _sfEncoding.syncWith(pOther->_sfEncoding);



}

void NameBase::execBeginEditImpl (const BitVector &whichField, 
                                                 UInt32     uiAspect,
                                                 UInt32     uiContainerSize)
{
    Inherited::execBeginEditImpl(whichField, uiAspect, uiContainerSize);

}
#endif



OSG_END_NAMESPACE

#include <OSGSFieldTypeDef.inl>

OSG_BEGIN_NAMESPACE

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_DEV)
DataType FieldDataTraits<NamePtr>::_type("NamePtr", "AttachmentPtr");
#endif

OSG_DLLEXPORT_SFIELD_DEF1(NamePtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);


/*------------------------------------------------------------------------*/
/*                              cvs id's                                  */

#ifdef OSG_SGI_CC
#pragma set woff 1174
#endif

#ifdef OSG_LINUX_ICC
#pragma warning( disable : 177 )
#endif

namespace
{
    static Char8 cvsid_cpp       [] = "@(#)$Id: FCBaseTemplate_cpp.h,v 1.49 2008/06/09 07:30:44 vossg Exp $";
    static Char8 cvsid_hpp       [] = OSGNAMEBASE_HEADER_CVSID;
    static Char8 cvsid_inl       [] = OSGNAMEBASE_INLINE_CVSID;

    static Char8 cvsid_fields_hpp[] = OSGNAMEFIELDS_HEADER_CVSID;
}

OSG_END_NAMESPACE

