/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class Transform3D!
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#define OSG_COMPILETRANSFORM3DINST

#include <stdlib.h>
#include <stdio.h>

#include <OSGConfig.h>

#include "OSGTransform3DBase.h"
#include "OSGTransform3D.h"


OSG_BEGIN_NAMESPACE

const OSG::BitVector  Transform3DBase::TranslationFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::TranslationFieldId);

const OSG::BitVector  Transform3DBase::EulerRotationFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::EulerRotationFieldId);

const OSG::BitVector  Transform3DBase::ScaleFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::ScaleFieldId);

const OSG::BitVector  Transform3DBase::RotationFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::RotationFieldId);

const OSG::BitVector  Transform3DBase::ShearFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::ShearFieldId);

const OSG::BitVector  Transform3DBase::ScalePivotFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::ScalePivotFieldId);

const OSG::BitVector  Transform3DBase::ScalePivotTranslationFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::ScalePivotTranslationFieldId);

const OSG::BitVector  Transform3DBase::RotatePivotFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::RotatePivotFieldId);

const OSG::BitVector  Transform3DBase::RotatePivotTranslationFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::RotatePivotTranslationFieldId);

const OSG::BitVector  Transform3DBase::RotationOrientationFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::RotationOrientationFieldId);

const OSG::BitVector  Transform3DBase::CenterFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::CenterFieldId);

const OSG::BitVector  Transform3DBase::RotationModeFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::RotationModeFieldId);

const OSG::BitVector  Transform3DBase::VersionFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::VersionFieldId);

const OSG::BitVector  Transform3DBase::EulerRotationOrientationFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::EulerRotationOrientationFieldId);

const OSG::BitVector  Transform3DBase::EulerRotationOrderFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::EulerRotationOrderFieldId);

const OSG::BitVector  Transform3DBase::FlagsFieldMask = 
    (TypeTraits<BitVector>::One << Transform3DBase::FlagsFieldId);

const OSG::BitVector Transform3DBase::MTInfluenceMask = 
    (Inherited::MTInfluenceMask) | 
    (static_cast<BitVector>(0x0) << Inherited::NextFieldId); 


// Field descriptions

/*! \var Vec3f           Transform3DBase::_sfTranslation
    
*/
/*! \var Vec3f           Transform3DBase::_sfEulerRotation
    
*/
/*! \var Vec3f           Transform3DBase::_sfScale
    
*/
/*! \var Quaternion      Transform3DBase::_sfRotation
    
*/
/*! \var Vec3f           Transform3DBase::_sfShear
    
*/
/*! \var Pnt3f           Transform3DBase::_sfScalePivot
    
*/
/*! \var Vec3f           Transform3DBase::_sfScalePivotTranslation
    
*/
/*! \var Pnt3f           Transform3DBase::_sfRotatePivot
    
*/
/*! \var Vec3f           Transform3DBase::_sfRotatePivotTranslation
    
*/
/*! \var Quaternion      Transform3DBase::_sfRotationOrientation
    
*/
/*! \var Pnt3f           Transform3DBase::_sfCenter
    
*/
/*! \var UInt32          Transform3DBase::_sfRotationMode
    
*/
/*! \var Real64          Transform3DBase::_sfVersion
    
*/
/*! \var Vec3f           Transform3DBase::_sfEulerRotationOrientation
    
*/
/*! \var std::string     Transform3DBase::_sfEulerRotationOrder
    
*/
/*! \var UInt64          Transform3DBase::_sfFlags
    
*/

//! Transform3D description

FieldDescription *Transform3DBase::_desc[] = 
{
    new FieldDescription(SFVec3f::getClassType(), 
                     "translation", 
                     TranslationFieldId, TranslationFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFTranslation)),
    new FieldDescription(SFVec3f::getClassType(), 
                     "eulerRotation", 
                     EulerRotationFieldId, EulerRotationFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFEulerRotation)),
    new FieldDescription(SFVec3f::getClassType(), 
                     "scale", 
                     ScaleFieldId, ScaleFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFScale)),
    new FieldDescription(SFQuaternion::getClassType(), 
                     "rotation", 
                     RotationFieldId, RotationFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFRotation)),
    new FieldDescription(SFVec3f::getClassType(), 
                     "shear", 
                     ShearFieldId, ShearFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFShear)),
    new FieldDescription(SFPnt3f::getClassType(), 
                     "scalePivot", 
                     ScalePivotFieldId, ScalePivotFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFScalePivot)),
    new FieldDescription(SFVec3f::getClassType(), 
                     "scalePivotTranslation", 
                     ScalePivotTranslationFieldId, ScalePivotTranslationFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFScalePivotTranslation)),
    new FieldDescription(SFPnt3f::getClassType(), 
                     "rotatePivot", 
                     RotatePivotFieldId, RotatePivotFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFRotatePivot)),
    new FieldDescription(SFVec3f::getClassType(), 
                     "rotatePivotTranslation", 
                     RotatePivotTranslationFieldId, RotatePivotTranslationFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFRotatePivotTranslation)),
    new FieldDescription(SFQuaternion::getClassType(), 
                     "rotationOrientation", 
                     RotationOrientationFieldId, RotationOrientationFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFRotationOrientation)),
    new FieldDescription(SFPnt3f::getClassType(), 
                     "center", 
                     CenterFieldId, CenterFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFCenter)),
    new FieldDescription(SFUInt32::getClassType(), 
                     "rotationMode", 
                     RotationModeFieldId, RotationModeFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFRotationMode)),
    new FieldDescription(SFReal64::getClassType(), 
                     "version", 
                     VersionFieldId, VersionFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFVersion)),
    new FieldDescription(SFVec3f::getClassType(), 
                     "eulerRotationOrientation", 
                     EulerRotationOrientationFieldId, EulerRotationOrientationFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFEulerRotationOrientation)),
    new FieldDescription(SFString::getClassType(), 
                     "eulerRotationOrder", 
                     EulerRotationOrderFieldId, EulerRotationOrderFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFEulerRotationOrder)),
    new FieldDescription(SFUInt64::getClassType(), 
                     "flags", 
                     FlagsFieldId, FlagsFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&Transform3DBase::editSFFlags))
};


FieldContainerType Transform3DBase::_type(
    "Transform3D",
    "Transform",
    NULL,
    reinterpret_cast<PrototypeCreateF>(&Transform3DBase::createEmpty),
    Transform3D::initMethod,
    _desc,
    sizeof(_desc));

//OSG_FIELD_CONTAINER_DEF(Transform3DBase, Transform3DPtr)

/*------------------------------ get -----------------------------------*/

FieldContainerType &Transform3DBase::getType(void) 
{
    return _type; 
} 

const FieldContainerType &Transform3DBase::getType(void) const 
{
    return _type;
} 


FieldContainerPtr Transform3DBase::shallowCopy(void) const 
{ 
    Transform3DPtr returnValue; 

    newPtr(returnValue, dynamic_cast<const Transform3D *>(this)); 

    return returnValue; 
}

UInt32 Transform3DBase::getContainerSize(void) const 
{ 
    return sizeof(Transform3D); 
}


#if !defined(OSG_FIXED_MFIELDSYNC)
void Transform3DBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField)
{
    this->executeSyncImpl(static_cast<Transform3DBase *>(&other),
                          whichField);
}
#else
void Transform3DBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField,                                    const SyncInfo       &sInfo     )
{
    this->executeSyncImpl((Transform3DBase *) &other, whichField, sInfo);
}
void Transform3DBase::execBeginEdit(const BitVector &whichField, 
                                            UInt32     uiAspect,
                                            UInt32     uiContainerSize) 
{
    this->execBeginEditImpl(whichField, uiAspect, uiContainerSize);
}

void Transform3DBase::onDestroyAspect(UInt32 uiId, UInt32 uiAspect)
{
    Inherited::onDestroyAspect(uiId, uiAspect);

}
#endif

/*------------------------- constructors ----------------------------------*/

#ifdef OSG_WIN32_ICL
#pragma warning (disable : 383)
#endif

Transform3DBase::Transform3DBase(void) :
    _sfTranslation            (Vec3f(0.0f, 0.0f, 0.0f)), 
    _sfEulerRotation          (Vec3f(0.0f, 0.0f, 0.0f)), 
    _sfScale                  (Vec3f(1.0f, 1.0f, 1.0f)), 
    _sfRotation               (), 
    _sfShear                  (Vec3f(0.0f, 0.0f, 0.0f)), 
    _sfScalePivot             (Pnt3f(0.0f, 0.0f, 0.0f)), 
    _sfScalePivotTranslation  (Vec3f(0.0f, 0.0f, 0.0f)), 
    _sfRotatePivot            (Pnt3f(0.0f, 0.0f, 0.0f)), 
    _sfRotatePivotTranslation (Vec3f(0.0f, 0.0f, 0.0f)), 
    _sfRotationOrientation    (), 
    _sfCenter                 (Pnt3f(0.0f, 0.0f, 0.0f)), 
    _sfRotationMode           (UInt32(0)), 
    _sfVersion                (Real64(0.0)), 
    _sfEulerRotationOrientation(Vec3f(0.0f, 0.0f, 0.0f)), 
    _sfEulerRotationOrder     (), 
    _sfFlags                  (), 
    Inherited() 
{
}

#ifdef OSG_WIN32_ICL
#pragma warning (default : 383)
#endif

Transform3DBase::Transform3DBase(const Transform3DBase &source) :
    _sfTranslation            (source._sfTranslation            ), 
    _sfEulerRotation          (source._sfEulerRotation          ), 
    _sfScale                  (source._sfScale                  ), 
    _sfRotation               (source._sfRotation               ), 
    _sfShear                  (source._sfShear                  ), 
    _sfScalePivot             (source._sfScalePivot             ), 
    _sfScalePivotTranslation  (source._sfScalePivotTranslation  ), 
    _sfRotatePivot            (source._sfRotatePivot            ), 
    _sfRotatePivotTranslation (source._sfRotatePivotTranslation ), 
    _sfRotationOrientation    (source._sfRotationOrientation    ), 
    _sfCenter                 (source._sfCenter                 ), 
    _sfRotationMode           (source._sfRotationMode           ), 
    _sfVersion                (source._sfVersion                ), 
    _sfEulerRotationOrientation(source._sfEulerRotationOrientation), 
    _sfEulerRotationOrder     (source._sfEulerRotationOrder     ), 
    _sfFlags                  (source._sfFlags                  ), 
    Inherited                 (source)
{
}

/*-------------------------- destructors ----------------------------------*/

Transform3DBase::~Transform3DBase(void)
{
}

/*------------------------------ access -----------------------------------*/

SizeT  Transform3DBase::getBinSize(const BitVector &whichField)
{
    SizeT returnValue = Inherited::getBinSize(whichField);

    if(FieldBits::NoField != (TranslationFieldMask & whichField))
    {
        returnValue += _sfTranslation.getBinSize();
    }

    if(FieldBits::NoField != (EulerRotationFieldMask & whichField))
    {
        returnValue += _sfEulerRotation.getBinSize();
    }

    if(FieldBits::NoField != (ScaleFieldMask & whichField))
    {
        returnValue += _sfScale.getBinSize();
    }

    if(FieldBits::NoField != (RotationFieldMask & whichField))
    {
        returnValue += _sfRotation.getBinSize();
    }

    if(FieldBits::NoField != (ShearFieldMask & whichField))
    {
        returnValue += _sfShear.getBinSize();
    }

    if(FieldBits::NoField != (ScalePivotFieldMask & whichField))
    {
        returnValue += _sfScalePivot.getBinSize();
    }

    if(FieldBits::NoField != (ScalePivotTranslationFieldMask & whichField))
    {
        returnValue += _sfScalePivotTranslation.getBinSize();
    }

    if(FieldBits::NoField != (RotatePivotFieldMask & whichField))
    {
        returnValue += _sfRotatePivot.getBinSize();
    }

    if(FieldBits::NoField != (RotatePivotTranslationFieldMask & whichField))
    {
        returnValue += _sfRotatePivotTranslation.getBinSize();
    }

    if(FieldBits::NoField != (RotationOrientationFieldMask & whichField))
    {
        returnValue += _sfRotationOrientation.getBinSize();
    }

    if(FieldBits::NoField != (CenterFieldMask & whichField))
    {
        returnValue += _sfCenter.getBinSize();
    }

    if(FieldBits::NoField != (RotationModeFieldMask & whichField))
    {
        returnValue += _sfRotationMode.getBinSize();
    }

    if(FieldBits::NoField != (VersionFieldMask & whichField))
    {
        returnValue += _sfVersion.getBinSize();
    }

    if(FieldBits::NoField != (EulerRotationOrientationFieldMask & whichField))
    {
        returnValue += _sfEulerRotationOrientation.getBinSize();
    }

    if(FieldBits::NoField != (EulerRotationOrderFieldMask & whichField))
    {
        returnValue += _sfEulerRotationOrder.getBinSize();
    }

    if(FieldBits::NoField != (FlagsFieldMask & whichField))
    {
        returnValue += _sfFlags.getBinSize();
    }


    return returnValue;
}

void Transform3DBase::copyToBin(      BinaryDataHandler &pMem,
                                  const BitVector         &whichField)
{
    Inherited::copyToBin(pMem, whichField);

    if(FieldBits::NoField != (TranslationFieldMask & whichField))
    {
        _sfTranslation.copyToBin(pMem);
    }

    if(FieldBits::NoField != (EulerRotationFieldMask & whichField))
    {
        _sfEulerRotation.copyToBin(pMem);
    }

    if(FieldBits::NoField != (ScaleFieldMask & whichField))
    {
        _sfScale.copyToBin(pMem);
    }

    if(FieldBits::NoField != (RotationFieldMask & whichField))
    {
        _sfRotation.copyToBin(pMem);
    }

    if(FieldBits::NoField != (ShearFieldMask & whichField))
    {
        _sfShear.copyToBin(pMem);
    }

    if(FieldBits::NoField != (ScalePivotFieldMask & whichField))
    {
        _sfScalePivot.copyToBin(pMem);
    }

    if(FieldBits::NoField != (ScalePivotTranslationFieldMask & whichField))
    {
        _sfScalePivotTranslation.copyToBin(pMem);
    }

    if(FieldBits::NoField != (RotatePivotFieldMask & whichField))
    {
        _sfRotatePivot.copyToBin(pMem);
    }

    if(FieldBits::NoField != (RotatePivotTranslationFieldMask & whichField))
    {
        _sfRotatePivotTranslation.copyToBin(pMem);
    }

    if(FieldBits::NoField != (RotationOrientationFieldMask & whichField))
    {
        _sfRotationOrientation.copyToBin(pMem);
    }

    if(FieldBits::NoField != (CenterFieldMask & whichField))
    {
        _sfCenter.copyToBin(pMem);
    }

    if(FieldBits::NoField != (RotationModeFieldMask & whichField))
    {
        _sfRotationMode.copyToBin(pMem);
    }

    if(FieldBits::NoField != (VersionFieldMask & whichField))
    {
        _sfVersion.copyToBin(pMem);
    }

    if(FieldBits::NoField != (EulerRotationOrientationFieldMask & whichField))
    {
        _sfEulerRotationOrientation.copyToBin(pMem);
    }

    if(FieldBits::NoField != (EulerRotationOrderFieldMask & whichField))
    {
        _sfEulerRotationOrder.copyToBin(pMem);
    }

    if(FieldBits::NoField != (FlagsFieldMask & whichField))
    {
        _sfFlags.copyToBin(pMem);
    }


}

void Transform3DBase::copyFromBin(      BinaryDataHandler &pMem,
                                    const BitVector    &whichField)
{
    Inherited::copyFromBin(pMem, whichField);

    if(FieldBits::NoField != (TranslationFieldMask & whichField))
    {
        _sfTranslation.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (EulerRotationFieldMask & whichField))
    {
        _sfEulerRotation.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (ScaleFieldMask & whichField))
    {
        _sfScale.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (RotationFieldMask & whichField))
    {
        _sfRotation.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (ShearFieldMask & whichField))
    {
        _sfShear.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (ScalePivotFieldMask & whichField))
    {
        _sfScalePivot.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (ScalePivotTranslationFieldMask & whichField))
    {
        _sfScalePivotTranslation.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (RotatePivotFieldMask & whichField))
    {
        _sfRotatePivot.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (RotatePivotTranslationFieldMask & whichField))
    {
        _sfRotatePivotTranslation.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (RotationOrientationFieldMask & whichField))
    {
        _sfRotationOrientation.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (CenterFieldMask & whichField))
    {
        _sfCenter.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (RotationModeFieldMask & whichField))
    {
        _sfRotationMode.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (VersionFieldMask & whichField))
    {
        _sfVersion.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (EulerRotationOrientationFieldMask & whichField))
    {
        _sfEulerRotationOrientation.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (EulerRotationOrderFieldMask & whichField))
    {
        _sfEulerRotationOrder.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (FlagsFieldMask & whichField))
    {
        _sfFlags.copyFromBin(pMem);
    }


}

#if !defined(OSG_FIXED_MFIELDSYNC)
void Transform3DBase::executeSyncImpl(      Transform3DBase *pOther,
                                        const BitVector         &whichField)
{

    Inherited::executeSyncImpl(pOther, whichField);

    if(FieldBits::NoField != (TranslationFieldMask & whichField))
        _sfTranslation.syncWith(pOther->_sfTranslation);

    if(FieldBits::NoField != (EulerRotationFieldMask & whichField))
        _sfEulerRotation.syncWith(pOther->_sfEulerRotation);

    if(FieldBits::NoField != (ScaleFieldMask & whichField))
        _sfScale.syncWith(pOther->_sfScale);

    if(FieldBits::NoField != (RotationFieldMask & whichField))
        _sfRotation.syncWith(pOther->_sfRotation);

    if(FieldBits::NoField != (ShearFieldMask & whichField))
        _sfShear.syncWith(pOther->_sfShear);

    if(FieldBits::NoField != (ScalePivotFieldMask & whichField))
        _sfScalePivot.syncWith(pOther->_sfScalePivot);

    if(FieldBits::NoField != (ScalePivotTranslationFieldMask & whichField))
        _sfScalePivotTranslation.syncWith(pOther->_sfScalePivotTranslation);

    if(FieldBits::NoField != (RotatePivotFieldMask & whichField))
        _sfRotatePivot.syncWith(pOther->_sfRotatePivot);

    if(FieldBits::NoField != (RotatePivotTranslationFieldMask & whichField))
        _sfRotatePivotTranslation.syncWith(pOther->_sfRotatePivotTranslation);

    if(FieldBits::NoField != (RotationOrientationFieldMask & whichField))
        _sfRotationOrientation.syncWith(pOther->_sfRotationOrientation);

    if(FieldBits::NoField != (CenterFieldMask & whichField))
        _sfCenter.syncWith(pOther->_sfCenter);

    if(FieldBits::NoField != (RotationModeFieldMask & whichField))
        _sfRotationMode.syncWith(pOther->_sfRotationMode);

    if(FieldBits::NoField != (VersionFieldMask & whichField))
        _sfVersion.syncWith(pOther->_sfVersion);

    if(FieldBits::NoField != (EulerRotationOrientationFieldMask & whichField))
        _sfEulerRotationOrientation.syncWith(pOther->_sfEulerRotationOrientation);

    if(FieldBits::NoField != (EulerRotationOrderFieldMask & whichField))
        _sfEulerRotationOrder.syncWith(pOther->_sfEulerRotationOrder);

    if(FieldBits::NoField != (FlagsFieldMask & whichField))
        _sfFlags.syncWith(pOther->_sfFlags);


}
#else
void Transform3DBase::executeSyncImpl(      Transform3DBase *pOther,
                                        const BitVector         &whichField,
                                        const SyncInfo          &sInfo      )
{

    Inherited::executeSyncImpl(pOther, whichField, sInfo);

    if(FieldBits::NoField != (TranslationFieldMask & whichField))
        _sfTranslation.syncWith(pOther->_sfTranslation);

    if(FieldBits::NoField != (EulerRotationFieldMask & whichField))
        _sfEulerRotation.syncWith(pOther->_sfEulerRotation);

    if(FieldBits::NoField != (ScaleFieldMask & whichField))
        _sfScale.syncWith(pOther->_sfScale);

    if(FieldBits::NoField != (RotationFieldMask & whichField))
        _sfRotation.syncWith(pOther->_sfRotation);

    if(FieldBits::NoField != (ShearFieldMask & whichField))
        _sfShear.syncWith(pOther->_sfShear);

    if(FieldBits::NoField != (ScalePivotFieldMask & whichField))
        _sfScalePivot.syncWith(pOther->_sfScalePivot);

    if(FieldBits::NoField != (ScalePivotTranslationFieldMask & whichField))
        _sfScalePivotTranslation.syncWith(pOther->_sfScalePivotTranslation);

    if(FieldBits::NoField != (RotatePivotFieldMask & whichField))
        _sfRotatePivot.syncWith(pOther->_sfRotatePivot);

    if(FieldBits::NoField != (RotatePivotTranslationFieldMask & whichField))
        _sfRotatePivotTranslation.syncWith(pOther->_sfRotatePivotTranslation);

    if(FieldBits::NoField != (RotationOrientationFieldMask & whichField))
        _sfRotationOrientation.syncWith(pOther->_sfRotationOrientation);

    if(FieldBits::NoField != (CenterFieldMask & whichField))
        _sfCenter.syncWith(pOther->_sfCenter);

    if(FieldBits::NoField != (RotationModeFieldMask & whichField))
        _sfRotationMode.syncWith(pOther->_sfRotationMode);

    if(FieldBits::NoField != (VersionFieldMask & whichField))
        _sfVersion.syncWith(pOther->_sfVersion);

    if(FieldBits::NoField != (EulerRotationOrientationFieldMask & whichField))
        _sfEulerRotationOrientation.syncWith(pOther->_sfEulerRotationOrientation);

    if(FieldBits::NoField != (EulerRotationOrderFieldMask & whichField))
        _sfEulerRotationOrder.syncWith(pOther->_sfEulerRotationOrder);

    if(FieldBits::NoField != (FlagsFieldMask & whichField))
        _sfFlags.syncWith(pOther->_sfFlags);



}

void Transform3DBase::execBeginEditImpl (const BitVector &whichField, 
                                                 UInt32     uiAspect,
                                                 UInt32     uiContainerSize)
{
    Inherited::execBeginEditImpl(whichField, uiAspect, uiContainerSize);

}
#endif



OSG_END_NAMESPACE

#include <OSGSFieldTypeDef.inl>
#include <OSGMFieldTypeDef.inl>

OSG_BEGIN_NAMESPACE

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_DEV)
DataType FieldDataTraits<Transform3DPtr>::_type("Transform3DPtr", "TransformPtr");
#endif

OSG_DLLEXPORT_SFIELD_DEF1(Transform3DPtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);
OSG_DLLEXPORT_MFIELD_DEF1(Transform3DPtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);


/*------------------------------------------------------------------------*/
/*                              cvs id's                                  */

#ifdef OSG_SGI_CC
#pragma set woff 1174
#endif

#ifdef OSG_LINUX_ICC
#pragma warning( disable : 177 )
#endif

namespace
{
    static Char8 cvsid_cpp       [] = "@(#)$Id: FCBaseTemplate_cpp.h,v 1.49 2008/06/09 07:30:44 vossg Exp $";
    static Char8 cvsid_hpp       [] = OSGTRANSFORM3DBASE_HEADER_CVSID;
    static Char8 cvsid_inl       [] = OSGTRANSFORM3DBASE_INLINE_CVSID;

    static Char8 cvsid_fields_hpp[] = OSGTRANSFORM3DFIELDS_HEADER_CVSID;
}

OSG_END_NAMESPACE

