/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class Transform!
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#define OSG_COMPILETRANSFORMINST

#include <stdlib.h>
#include <stdio.h>

#include <OSGConfig.h>

#include "OSGTransformBase.h"
#include "OSGTransform.h"


OSG_BEGIN_NAMESPACE

const OSG::BitVector  TransformBase::MatrixFieldMask = 
    (TypeTraits<BitVector>::One << TransformBase::MatrixFieldId);

const OSG::BitVector  TransformBase::IsIdentityFieldMask = 
    (TypeTraits<BitVector>::One << TransformBase::IsIdentityFieldId);

const OSG::BitVector TransformBase::MTInfluenceMask = 
    (Inherited::MTInfluenceMask) | 
    (static_cast<BitVector>(0x0) << Inherited::NextFieldId); 


// Field descriptions

/*! \var Matrix          TransformBase::_sfMatrix
    The transformation matrix.
*/
/*! \var bool            TransformBase::_sfIsIdentity
    The transformation matrix.
*/

//! Transform description

FieldDescription *TransformBase::_desc[] = 
{
    new FieldDescription(SFMatrix::getClassType(), 
                     "matrix", 
                     MatrixFieldId, MatrixFieldMask,
                     FieldDescription::FDExternal,
                     reinterpret_cast<FieldAccessMethod>(&TransformBase::editSFMatrix)),
    new FieldDescription(SFBool::getClassType(), 
                     "isIdentity", 
                     IsIdentityFieldId, IsIdentityFieldMask,
                     FieldDescription::FDInternal,
                     reinterpret_cast<FieldAccessMethod>(&TransformBase::editSFIsIdentity))
};


FieldContainerType TransformBase::_type(
    "Transform",
    "Group",
    NULL,
    reinterpret_cast<PrototypeCreateF>(&TransformBase::createEmpty),
    Transform::initMethod,
    _desc,
    sizeof(_desc));

//OSG_FIELD_CONTAINER_DEF(TransformBase, TransformPtr)

/*------------------------------ get -----------------------------------*/

FieldContainerType &TransformBase::getType(void) 
{
    return _type; 
} 

const FieldContainerType &TransformBase::getType(void) const 
{
    return _type;
} 


FieldContainerPtr TransformBase::shallowCopy(void) const 
{ 
    TransformPtr returnValue; 

    newPtr(returnValue, dynamic_cast<const Transform *>(this)); 

    return returnValue; 
}

UInt32 TransformBase::getContainerSize(void) const 
{ 
    return sizeof(Transform); 
}


#if !defined(OSG_FIXED_MFIELDSYNC)
void TransformBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField)
{
    this->executeSyncImpl(static_cast<TransformBase *>(&other),
                          whichField);
}
#else
void TransformBase::executeSync(      FieldContainer &other,
                                    const BitVector      &whichField,                                    const SyncInfo       &sInfo     )
{
    this->executeSyncImpl((TransformBase *) &other, whichField, sInfo);
}
void TransformBase::execBeginEdit(const BitVector &whichField, 
                                            UInt32     uiAspect,
                                            UInt32     uiContainerSize) 
{
    this->execBeginEditImpl(whichField, uiAspect, uiContainerSize);
}

void TransformBase::onDestroyAspect(UInt32 uiId, UInt32 uiAspect)
{
    Inherited::onDestroyAspect(uiId, uiAspect);

}
#endif

/*------------------------- constructors ----------------------------------*/

#ifdef OSG_WIN32_ICL
#pragma warning (disable : 383)
#endif

TransformBase::TransformBase(void) :
    _sfMatrix                 (Matrix(1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f, 0.0f, 0.0f, 0.0f, 0.0f, 1.0f)), 
    _sfIsIdentity             (bool(true)), 
    Inherited() 
{
}

#ifdef OSG_WIN32_ICL
#pragma warning (default : 383)
#endif

TransformBase::TransformBase(const TransformBase &source) :
    _sfMatrix                 (source._sfMatrix                 ), 
    _sfIsIdentity             (source._sfIsIdentity             ), 
    Inherited                 (source)
{
}

/*-------------------------- destructors ----------------------------------*/

TransformBase::~TransformBase(void)
{
}

/*------------------------------ access -----------------------------------*/

SizeT  TransformBase::getBinSize(const BitVector &whichField)
{
    SizeT returnValue = Inherited::getBinSize(whichField);

    if(FieldBits::NoField != (MatrixFieldMask & whichField))
    {
        returnValue += _sfMatrix.getBinSize();
    }

    if(FieldBits::NoField != (IsIdentityFieldMask & whichField))
    {
        returnValue += _sfIsIdentity.getBinSize();
    }


    return returnValue;
}

void TransformBase::copyToBin(      BinaryDataHandler &pMem,
                                  const BitVector         &whichField)
{
    Inherited::copyToBin(pMem, whichField);

    if(FieldBits::NoField != (MatrixFieldMask & whichField))
    {
        _sfMatrix.copyToBin(pMem);
    }

    if(FieldBits::NoField != (IsIdentityFieldMask & whichField))
    {
        _sfIsIdentity.copyToBin(pMem);
    }


}

void TransformBase::copyFromBin(      BinaryDataHandler &pMem,
                                    const BitVector    &whichField)
{
    Inherited::copyFromBin(pMem, whichField);

    if(FieldBits::NoField != (MatrixFieldMask & whichField))
    {
        _sfMatrix.copyFromBin(pMem);
    }

    if(FieldBits::NoField != (IsIdentityFieldMask & whichField))
    {
        _sfIsIdentity.copyFromBin(pMem);
    }


}

#if !defined(OSG_FIXED_MFIELDSYNC)
void TransformBase::executeSyncImpl(      TransformBase *pOther,
                                        const BitVector         &whichField)
{

    Inherited::executeSyncImpl(pOther, whichField);

    if(FieldBits::NoField != (MatrixFieldMask & whichField))
        _sfMatrix.syncWith(pOther->_sfMatrix);

    if(FieldBits::NoField != (IsIdentityFieldMask & whichField))
        _sfIsIdentity.syncWith(pOther->_sfIsIdentity);


}
#else
void TransformBase::executeSyncImpl(      TransformBase *pOther,
                                        const BitVector         &whichField,
                                        const SyncInfo          &sInfo      )
{

    Inherited::executeSyncImpl(pOther, whichField, sInfo);

    if(FieldBits::NoField != (MatrixFieldMask & whichField))
        _sfMatrix.syncWith(pOther->_sfMatrix);

    if(FieldBits::NoField != (IsIdentityFieldMask & whichField))
        _sfIsIdentity.syncWith(pOther->_sfIsIdentity);



}

void TransformBase::execBeginEditImpl (const BitVector &whichField, 
                                                 UInt32     uiAspect,
                                                 UInt32     uiContainerSize)
{
    Inherited::execBeginEditImpl(whichField, uiAspect, uiContainerSize);

}
#endif



OSG_END_NAMESPACE

#include <OSGSFieldTypeDef.inl>
#include <OSGMFieldTypeDef.inl>

OSG_BEGIN_NAMESPACE

#if !defined(OSG_DO_DOC) || defined(OSG_DOC_DEV)
DataType FieldDataTraits<TransformPtr>::_type("TransformPtr", "GroupPtr");
#endif

OSG_DLLEXPORT_SFIELD_DEF1(TransformPtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);
OSG_DLLEXPORT_MFIELD_DEF1(TransformPtr, OSG_SYSTEMLIB_DLLTMPLMAPPING);


/*------------------------------------------------------------------------*/
/*                              cvs id's                                  */

#ifdef OSG_SGI_CC
#pragma set woff 1174
#endif

#ifdef OSG_LINUX_ICC
#pragma warning( disable : 177 )
#endif

namespace
{
    static Char8 cvsid_cpp       [] = "@(#)$Id: FCBaseTemplate_cpp.h,v 1.49 2008/06/09 07:30:44 vossg Exp $";
    static Char8 cvsid_hpp       [] = OSGTRANSFORMBASE_HEADER_CVSID;
    static Char8 cvsid_inl       [] = OSGTRANSFORMBASE_INLINE_CVSID;

    static Char8 cvsid_fields_hpp[] = OSGTRANSFORMFIELDS_HEADER_CVSID;
}

OSG_END_NAMESPACE

