/*---------------------------------------------------------------------------*\
 *                                OpenSG                                     *
 *                                                                           *
 *                                                                           *
 *               Copyright (C) 2000-2002 by the OpenSG Forum                 *
 *                                                                           *
 *                            www.opensg.org                                 *
 *                                                                           *
 *   contact: dirk@opensg.org, gerrit.voss@vossg.org, jbehr@zgdv.de          *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                License                                    *
 *                                                                           *
 * This library is free software; you can redistribute it and/or modify it   *
 * under the terms of the GNU Library General Public License as published    *
 * by the Free Software Foundation, version 2.                               *
 *                                                                           *
 * This library is distributed in the hope that it will be useful, but       *
 * WITHOUT ANY WARRANTY; without even the implied warranty of                *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU         *
 * Library General Public License for more details.                          *
 *                                                                           *
 * You should have received a copy of the GNU Library General Public         *
 * License along with this library; if not, write to the Free Software       *
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.                 *
 *                                                                           *
\*---------------------------------------------------------------------------*/
/*---------------------------------------------------------------------------*\
 *                                Changes                                    *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
 *                                                                           *
\*---------------------------------------------------------------------------*/

/*****************************************************************************\
 *****************************************************************************
 **                                                                         **
 **                  This file is automatically generated.                  **
 **                                                                         **
 **          Any changes made to this file WILL be lost when it is          **
 **           regenerated, which can become necessary at any time.          **
 **                                                                         **
 **     Do not change this file, changes should be done in the derived      **
 **     class TextureChunk
 **                                                                         **
 *****************************************************************************
\*****************************************************************************/


#ifndef _OSGTEXTURECHUNKBASE_H_
#define _OSGTEXTURECHUNKBASE_H_
#pragma once


#include <OSGConfig.h>
#include <OSGSystemDef.h>

#include <OSGBaseTypes.h>
#include <OSGRefPtr.h>
#include <OSGCoredNodePtr.h>

#include <OSGStateChunk.h> // Parent

#include <OSGImageFields.h> // Image type
#include <OSGGLenumFields.h> // InternalFormat type
#include <OSGGLenumFields.h> // ExternalFormat type
#include <OSGBoolFields.h> // Scale type
#include <OSGUInt32Fields.h> // Frame type
#include <OSGGLenumFields.h> // MinFilter type
#include <OSGGLenumFields.h> // MagFilter type
#include <OSGGLenumFields.h> // WrapS type
#include <OSGGLenumFields.h> // WrapT type
#include <OSGGLenumFields.h> // WrapR type
#include <OSGGLenumFields.h> // EnvMode type
#include <OSGColor4fFields.h> // EnvColor type
#include <OSGGLenumFields.h> // EnvCombineRGB type
#include <OSGGLenumFields.h> // EnvCombineAlpha type
#include <OSGReal32Fields.h> // EnvScaleRGB type
#include <OSGReal32Fields.h> // EnvScaleAlpha type
#include <OSGGLenumFields.h> // EnvSource0RGB type
#include <OSGGLenumFields.h> // EnvSource1RGB type
#include <OSGGLenumFields.h> // EnvSource2RGB type
#include <OSGGLenumFields.h> // EnvSource0Alpha type
#include <OSGGLenumFields.h> // EnvSource1Alpha type
#include <OSGGLenumFields.h> // EnvSource2Alpha type
#include <OSGGLenumFields.h> // EnvOperand0RGB type
#include <OSGGLenumFields.h> // EnvOperand1RGB type
#include <OSGGLenumFields.h> // EnvOperand2RGB type
#include <OSGGLenumFields.h> // EnvOperand0Alpha type
#include <OSGGLenumFields.h> // EnvOperand1Alpha type
#include <OSGGLenumFields.h> // EnvOperand2Alpha type
#include <OSGGLenumFields.h> // GLId type
#include <OSGInt32Fields.h> // IgnoreGLForAspect type
#include <OSGBoolFields.h> // PointSprite type
#include <OSGReal32Fields.h> // Priority type
#include <OSGGLenumFields.h> // ShaderOperation type
#include <OSGGLenumFields.h> // ShaderInput type
#include <OSGReal32Fields.h> // ShaderOffsetMatrix type
#include <OSGReal32Fields.h> // ShaderOffsetScale type
#include <OSGReal32Fields.h> // ShaderOffsetBias type
#include <OSGGLenumFields.h> // ShaderRGBADotProduct type
#include <OSGUInt8Fields.h> // ShaderCullModes type
#include <OSGVec3fFields.h> // ShaderConstEye type
#include <OSGReal32Fields.h> // LodBias type
#include <OSGGLenumFields.h> // Target type
#include <OSGInt32Fields.h> // DirtyLeft type
#include <OSGInt32Fields.h> // DirtyMinX type
#include <OSGInt32Fields.h> // DirtyMaxX type
#include <OSGInt32Fields.h> // DirtyMinY type
#include <OSGInt32Fields.h> // DirtyMaxY type
#include <OSGInt32Fields.h> // DirtyMinZ type
#include <OSGInt32Fields.h> // DirtyMaxZ type
#include <OSGReal32Fields.h> // Anisotropy type
#include <OSGColor4fFields.h> // BorderColor type
#include <OSGUInt32Fields.h> // BorderWidth type
#include <OSGUInt32Fields.h> // NPOTMatrixScale type
#include <OSGReal32Fields.h> // SkipMipMapLevels type

#include <OSGTextureChunkFields.h>

OSG_BEGIN_NAMESPACE

class TextureChunk;
class BinaryDataHandler;

//! \brief TextureChunk Base Class.

class OSG_SYSTEMLIB_DLLMAPPING TextureChunkBase : public StateChunk
{
  private:

    typedef StateChunk    Inherited;

    /*==========================  PUBLIC  =================================*/
  public:

    typedef TextureChunkPtr  Ptr;

    enum
    {
        ImageFieldId                = Inherited::NextFieldId,
        InternalFormatFieldId       = ImageFieldId                + 1,
        ExternalFormatFieldId       = InternalFormatFieldId       + 1,
        ScaleFieldId                = ExternalFormatFieldId       + 1,
        FrameFieldId                = ScaleFieldId                + 1,
        MinFilterFieldId            = FrameFieldId                + 1,
        MagFilterFieldId            = MinFilterFieldId            + 1,
        WrapSFieldId                = MagFilterFieldId            + 1,
        WrapTFieldId                = WrapSFieldId                + 1,
        WrapRFieldId                = WrapTFieldId                + 1,
        EnvModeFieldId              = WrapRFieldId                + 1,
        EnvColorFieldId             = EnvModeFieldId              + 1,
        EnvCombineRGBFieldId        = EnvColorFieldId             + 1,
        EnvCombineAlphaFieldId      = EnvCombineRGBFieldId        + 1,
        EnvScaleRGBFieldId          = EnvCombineAlphaFieldId      + 1,
        EnvScaleAlphaFieldId        = EnvScaleRGBFieldId          + 1,
        EnvSource0RGBFieldId        = EnvScaleAlphaFieldId        + 1,
        EnvSource1RGBFieldId        = EnvSource0RGBFieldId        + 1,
        EnvSource2RGBFieldId        = EnvSource1RGBFieldId        + 1,
        EnvSource0AlphaFieldId      = EnvSource2RGBFieldId        + 1,
        EnvSource1AlphaFieldId      = EnvSource0AlphaFieldId      + 1,
        EnvSource2AlphaFieldId      = EnvSource1AlphaFieldId      + 1,
        EnvOperand0RGBFieldId       = EnvSource2AlphaFieldId      + 1,
        EnvOperand1RGBFieldId       = EnvOperand0RGBFieldId       + 1,
        EnvOperand2RGBFieldId       = EnvOperand1RGBFieldId       + 1,
        EnvOperand0AlphaFieldId     = EnvOperand2RGBFieldId       + 1,
        EnvOperand1AlphaFieldId     = EnvOperand0AlphaFieldId     + 1,
        EnvOperand2AlphaFieldId     = EnvOperand1AlphaFieldId     + 1,
        GLIdFieldId                 = EnvOperand2AlphaFieldId     + 1,
        IgnoreGLForAspectFieldId    = GLIdFieldId                 + 1,
        PointSpriteFieldId          = IgnoreGLForAspectFieldId    + 1,
        PriorityFieldId             = PointSpriteFieldId          + 1,
        ShaderOperationFieldId      = PriorityFieldId             + 1,
        ShaderInputFieldId          = ShaderOperationFieldId      + 1,
        ShaderOffsetMatrixFieldId   = ShaderInputFieldId          + 1,
        ShaderOffsetScaleFieldId    = ShaderOffsetMatrixFieldId   + 1,
        ShaderOffsetBiasFieldId     = ShaderOffsetScaleFieldId    + 1,
        ShaderRGBADotProductFieldId = ShaderOffsetBiasFieldId     + 1,
        ShaderCullModesFieldId      = ShaderRGBADotProductFieldId + 1,
        ShaderConstEyeFieldId       = ShaderCullModesFieldId      + 1,
        LodBiasFieldId              = ShaderConstEyeFieldId       + 1,
        TargetFieldId               = LodBiasFieldId              + 1,
        DirtyLeftFieldId            = TargetFieldId               + 1,
        DirtyMinXFieldId            = DirtyLeftFieldId            + 1,
        DirtyMaxXFieldId            = DirtyMinXFieldId            + 1,
        DirtyMinYFieldId            = DirtyMaxXFieldId            + 1,
        DirtyMaxYFieldId            = DirtyMinYFieldId            + 1,
        DirtyMinZFieldId            = DirtyMaxYFieldId            + 1,
        DirtyMaxZFieldId            = DirtyMinZFieldId            + 1,
        AnisotropyFieldId           = DirtyMaxZFieldId            + 1,
        BorderColorFieldId          = AnisotropyFieldId           + 1,
        BorderWidthFieldId          = BorderColorFieldId          + 1,
        NPOTMatrixScaleFieldId      = BorderWidthFieldId          + 1,
        SkipMipMapLevelsFieldId     = NPOTMatrixScaleFieldId      + 1,
        NextFieldId                 = SkipMipMapLevelsFieldId     + 1
    };

    static const OSG::BitVector ImageFieldMask;
    static const OSG::BitVector InternalFormatFieldMask;
    static const OSG::BitVector ExternalFormatFieldMask;
    static const OSG::BitVector ScaleFieldMask;
    static const OSG::BitVector FrameFieldMask;
    static const OSG::BitVector MinFilterFieldMask;
    static const OSG::BitVector MagFilterFieldMask;
    static const OSG::BitVector WrapSFieldMask;
    static const OSG::BitVector WrapTFieldMask;
    static const OSG::BitVector WrapRFieldMask;
    static const OSG::BitVector EnvModeFieldMask;
    static const OSG::BitVector EnvColorFieldMask;
    static const OSG::BitVector EnvCombineRGBFieldMask;
    static const OSG::BitVector EnvCombineAlphaFieldMask;
    static const OSG::BitVector EnvScaleRGBFieldMask;
    static const OSG::BitVector EnvScaleAlphaFieldMask;
    static const OSG::BitVector EnvSource0RGBFieldMask;
    static const OSG::BitVector EnvSource1RGBFieldMask;
    static const OSG::BitVector EnvSource2RGBFieldMask;
    static const OSG::BitVector EnvSource0AlphaFieldMask;
    static const OSG::BitVector EnvSource1AlphaFieldMask;
    static const OSG::BitVector EnvSource2AlphaFieldMask;
    static const OSG::BitVector EnvOperand0RGBFieldMask;
    static const OSG::BitVector EnvOperand1RGBFieldMask;
    static const OSG::BitVector EnvOperand2RGBFieldMask;
    static const OSG::BitVector EnvOperand0AlphaFieldMask;
    static const OSG::BitVector EnvOperand1AlphaFieldMask;
    static const OSG::BitVector EnvOperand2AlphaFieldMask;
    static const OSG::BitVector GLIdFieldMask;
    static const OSG::BitVector IgnoreGLForAspectFieldMask;
    static const OSG::BitVector PointSpriteFieldMask;
    static const OSG::BitVector PriorityFieldMask;
    static const OSG::BitVector ShaderOperationFieldMask;
    static const OSG::BitVector ShaderInputFieldMask;
    static const OSG::BitVector ShaderOffsetMatrixFieldMask;
    static const OSG::BitVector ShaderOffsetScaleFieldMask;
    static const OSG::BitVector ShaderOffsetBiasFieldMask;
    static const OSG::BitVector ShaderRGBADotProductFieldMask;
    static const OSG::BitVector ShaderCullModesFieldMask;
    static const OSG::BitVector ShaderConstEyeFieldMask;
    static const OSG::BitVector LodBiasFieldMask;
    static const OSG::BitVector TargetFieldMask;
    static const OSG::BitVector DirtyLeftFieldMask;
    static const OSG::BitVector DirtyMinXFieldMask;
    static const OSG::BitVector DirtyMaxXFieldMask;
    static const OSG::BitVector DirtyMinYFieldMask;
    static const OSG::BitVector DirtyMaxYFieldMask;
    static const OSG::BitVector DirtyMinZFieldMask;
    static const OSG::BitVector DirtyMaxZFieldMask;
    static const OSG::BitVector AnisotropyFieldMask;
    static const OSG::BitVector BorderColorFieldMask;
    static const OSG::BitVector BorderWidthFieldMask;
    static const OSG::BitVector NPOTMatrixScaleFieldMask;
    static const OSG::BitVector SkipMipMapLevelsFieldMask;


    static const OSG::BitVector MTInfluenceMask;

    /*---------------------------------------------------------------------*/
    /*! \name                    Class Get                                 */
    /*! \{                                                                 */

    static        FieldContainerType &getClassType    (void); 
    static        UInt32              getClassTypeId  (void); 

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                FieldContainer Get                            */
    /*! \{                                                                 */

    virtual       FieldContainerType &getType  (void); 
    virtual const FieldContainerType &getType  (void) const; 

    virtual       UInt32              getContainerSize(void) const;

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                    Field Get                                 */
    /*! \{                                                                 */


           SFImagePtr          *editSFImage          (void);
     const SFImagePtr          *getSFImage          (void) const;
#ifndef OSG_2_PREP
           SFImagePtr          *getSFImage          (void);
#endif

           SFGLenum            *editSFInternalFormat (void);
     const SFGLenum            *getSFInternalFormat (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFInternalFormat (void);
#endif

           SFGLenum            *editSFExternalFormat (void);
     const SFGLenum            *getSFExternalFormat (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFExternalFormat (void);
#endif

           SFBool              *editSFScale          (void);
     const SFBool              *getSFScale          (void) const;
#ifndef OSG_2_PREP
           SFBool              *getSFScale          (void);
#endif

           SFUInt32            *editSFFrame          (void);
     const SFUInt32            *getSFFrame          (void) const;
#ifndef OSG_2_PREP
           SFUInt32            *getSFFrame          (void);
#endif

           SFGLenum            *editSFMinFilter      (void);
     const SFGLenum            *getSFMinFilter      (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFMinFilter      (void);
#endif

           SFGLenum            *editSFMagFilter      (void);
     const SFGLenum            *getSFMagFilter      (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFMagFilter      (void);
#endif

           SFGLenum            *editSFWrapS          (void);
     const SFGLenum            *getSFWrapS          (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFWrapS          (void);
#endif

           SFGLenum            *editSFWrapT          (void);
     const SFGLenum            *getSFWrapT          (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFWrapT          (void);
#endif

           SFGLenum            *editSFWrapR          (void);
     const SFGLenum            *getSFWrapR          (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFWrapR          (void);
#endif

           SFGLenum            *editSFEnvMode        (void);
     const SFGLenum            *getSFEnvMode        (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvMode        (void);
#endif

           SFColor4f           *editSFEnvColor       (void);
     const SFColor4f           *getSFEnvColor       (void) const;
#ifndef OSG_2_PREP
           SFColor4f           *getSFEnvColor       (void);
#endif

           SFGLenum            *editSFEnvCombineRGB  (void);
     const SFGLenum            *getSFEnvCombineRGB  (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvCombineRGB  (void);
#endif

           SFGLenum            *editSFEnvCombineAlpha(void);
     const SFGLenum            *getSFEnvCombineAlpha(void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvCombineAlpha(void);
#endif

           SFReal32            *editSFEnvScaleRGB    (void);
     const SFReal32            *getSFEnvScaleRGB    (void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFEnvScaleRGB    (void);
#endif

           SFReal32            *editSFEnvScaleAlpha  (void);
     const SFReal32            *getSFEnvScaleAlpha  (void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFEnvScaleAlpha  (void);
#endif

           SFGLenum            *editSFEnvSource0RGB  (void);
     const SFGLenum            *getSFEnvSource0RGB  (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvSource0RGB  (void);
#endif

           SFGLenum            *editSFEnvSource1RGB  (void);
     const SFGLenum            *getSFEnvSource1RGB  (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvSource1RGB  (void);
#endif

           SFGLenum            *editSFEnvSource2RGB  (void);
     const SFGLenum            *getSFEnvSource2RGB  (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvSource2RGB  (void);
#endif

           SFGLenum            *editSFEnvSource0Alpha(void);
     const SFGLenum            *getSFEnvSource0Alpha(void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvSource0Alpha(void);
#endif

           SFGLenum            *editSFEnvSource1Alpha(void);
     const SFGLenum            *getSFEnvSource1Alpha(void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvSource1Alpha(void);
#endif

           SFGLenum            *editSFEnvSource2Alpha(void);
     const SFGLenum            *getSFEnvSource2Alpha(void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvSource2Alpha(void);
#endif

           SFGLenum            *editSFEnvOperand0RGB (void);
     const SFGLenum            *getSFEnvOperand0RGB (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvOperand0RGB (void);
#endif

           SFGLenum            *editSFEnvOperand1RGB (void);
     const SFGLenum            *getSFEnvOperand1RGB (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvOperand1RGB (void);
#endif

           SFGLenum            *editSFEnvOperand2RGB (void);
     const SFGLenum            *getSFEnvOperand2RGB (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvOperand2RGB (void);
#endif

           SFGLenum            *editSFEnvOperand0Alpha(void);
     const SFGLenum            *getSFEnvOperand0Alpha(void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvOperand0Alpha(void);
#endif

           SFGLenum            *editSFEnvOperand1Alpha(void);
     const SFGLenum            *getSFEnvOperand1Alpha(void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvOperand1Alpha(void);
#endif

           SFGLenum            *editSFEnvOperand2Alpha(void);
     const SFGLenum            *getSFEnvOperand2Alpha(void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFEnvOperand2Alpha(void);
#endif

           SFGLenum            *editSFGLId           (void);
     const SFGLenum            *getSFGLId           (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFGLId           (void);
#endif

           SFInt32             *editSFIgnoreGLForAspect(void);
     const SFInt32             *getSFIgnoreGLForAspect(void) const;
#ifndef OSG_2_PREP
           SFInt32             *getSFIgnoreGLForAspect(void);
#endif

           SFBool              *editSFPointSprite    (void);
     const SFBool              *getSFPointSprite    (void) const;
#ifndef OSG_2_PREP
           SFBool              *getSFPointSprite    (void);
#endif

           SFReal32            *editSFPriority       (void);
     const SFReal32            *getSFPriority       (void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFPriority       (void);
#endif

           SFGLenum            *editSFShaderOperation(void);
     const SFGLenum            *getSFShaderOperation(void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFShaderOperation(void);
#endif

           SFGLenum            *editSFShaderInput    (void);
     const SFGLenum            *getSFShaderInput    (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFShaderInput    (void);
#endif

           MFReal32            *editMFShaderOffsetMatrix(void);
     const MFReal32            *getMFShaderOffsetMatrix(void) const;
#ifndef OSG_2_PREP
           MFReal32            *getMFShaderOffsetMatrix(void);
#endif

           SFReal32            *editSFShaderOffsetScale(void);
     const SFReal32            *getSFShaderOffsetScale(void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFShaderOffsetScale(void);
#endif

           SFReal32            *editSFShaderOffsetBias(void);
     const SFReal32            *getSFShaderOffsetBias(void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFShaderOffsetBias(void);
#endif

           SFGLenum            *editSFShaderRGBADotProduct(void);
     const SFGLenum            *getSFShaderRGBADotProduct(void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFShaderRGBADotProduct(void);
#endif

           SFUInt8             *editSFShaderCullModes(void);
     const SFUInt8             *getSFShaderCullModes(void) const;
#ifndef OSG_2_PREP
           SFUInt8             *getSFShaderCullModes(void);
#endif

           SFVec3f             *editSFShaderConstEye (void);
     const SFVec3f             *getSFShaderConstEye (void) const;
#ifndef OSG_2_PREP
           SFVec3f             *getSFShaderConstEye (void);
#endif

           SFReal32            *editSFLodBias        (void);
     const SFReal32            *getSFLodBias        (void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFLodBias        (void);
#endif

           SFGLenum            *editSFTarget         (void);
     const SFGLenum            *getSFTarget         (void) const;
#ifndef OSG_2_PREP
           SFGLenum            *getSFTarget         (void);
#endif

           SFInt32             *editSFDirtyLeft      (void);
     const SFInt32             *getSFDirtyLeft      (void) const;
#ifndef OSG_2_PREP
           SFInt32             *getSFDirtyLeft      (void);
#endif

           SFInt32             *editSFDirtyMinX      (void);
     const SFInt32             *getSFDirtyMinX      (void) const;
#ifndef OSG_2_PREP
           SFInt32             *getSFDirtyMinX      (void);
#endif

           SFInt32             *editSFDirtyMaxX      (void);
     const SFInt32             *getSFDirtyMaxX      (void) const;
#ifndef OSG_2_PREP
           SFInt32             *getSFDirtyMaxX      (void);
#endif

           SFInt32             *editSFDirtyMinY      (void);
     const SFInt32             *getSFDirtyMinY      (void) const;
#ifndef OSG_2_PREP
           SFInt32             *getSFDirtyMinY      (void);
#endif

           SFInt32             *editSFDirtyMaxY      (void);
     const SFInt32             *getSFDirtyMaxY      (void) const;
#ifndef OSG_2_PREP
           SFInt32             *getSFDirtyMaxY      (void);
#endif

           SFInt32             *editSFDirtyMinZ      (void);
     const SFInt32             *getSFDirtyMinZ      (void) const;
#ifndef OSG_2_PREP
           SFInt32             *getSFDirtyMinZ      (void);
#endif

           SFInt32             *editSFDirtyMaxZ      (void);
     const SFInt32             *getSFDirtyMaxZ      (void) const;
#ifndef OSG_2_PREP
           SFInt32             *getSFDirtyMaxZ      (void);
#endif

           SFReal32            *editSFAnisotropy     (void);
     const SFReal32            *getSFAnisotropy     (void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFAnisotropy     (void);
#endif

           SFColor4f           *editSFBorderColor    (void);
     const SFColor4f           *getSFBorderColor    (void) const;
#ifndef OSG_2_PREP
           SFColor4f           *getSFBorderColor    (void);
#endif

           SFUInt32            *editSFBorderWidth    (void);
     const SFUInt32            *getSFBorderWidth    (void) const;
#ifndef OSG_2_PREP
           SFUInt32            *getSFBorderWidth    (void);
#endif

           SFUInt32            *editSFNPOTMatrixScale(void);
     const SFUInt32            *getSFNPOTMatrixScale(void) const;
#ifndef OSG_2_PREP
           SFUInt32            *getSFNPOTMatrixScale(void);
#endif

           SFReal32            *editSFSkipMipMapLevels(void);
     const SFReal32            *getSFSkipMipMapLevels(void) const;
#ifndef OSG_2_PREP
           SFReal32            *getSFSkipMipMapLevels(void);
#endif


           ImagePtr            &editImage          (void);
     const ImagePtr            &getImage          (void) const;
#ifndef OSG_2_PREP
           ImagePtr            &getImage          (void);
#endif

           GLenum              &editInternalFormat (void);
     const GLenum              &getInternalFormat (void) const;
#ifndef OSG_2_PREP
           GLenum              &getInternalFormat (void);
#endif

           GLenum              &editExternalFormat (void);
     const GLenum              &getExternalFormat (void) const;
#ifndef OSG_2_PREP
           GLenum              &getExternalFormat (void);
#endif

           bool                &editScale          (void);
     const bool                &getScale          (void) const;
#ifndef OSG_2_PREP
           bool                &getScale          (void);
#endif

           UInt32              &editFrame          (void);
     const UInt32              &getFrame          (void) const;
#ifndef OSG_2_PREP
           UInt32              &getFrame          (void);
#endif

           GLenum              &editMinFilter      (void);
     const GLenum              &getMinFilter      (void) const;
#ifndef OSG_2_PREP
           GLenum              &getMinFilter      (void);
#endif

           GLenum              &editMagFilter      (void);
     const GLenum              &getMagFilter      (void) const;
#ifndef OSG_2_PREP
           GLenum              &getMagFilter      (void);
#endif

           GLenum              &editWrapS          (void);
     const GLenum              &getWrapS          (void) const;
#ifndef OSG_2_PREP
           GLenum              &getWrapS          (void);
#endif

           GLenum              &editWrapT          (void);
     const GLenum              &getWrapT          (void) const;
#ifndef OSG_2_PREP
           GLenum              &getWrapT          (void);
#endif

           GLenum              &editWrapR          (void);
     const GLenum              &getWrapR          (void) const;
#ifndef OSG_2_PREP
           GLenum              &getWrapR          (void);
#endif

           GLenum              &editEnvMode        (void);
     const GLenum              &getEnvMode        (void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvMode        (void);
#endif

           Color4f             &editEnvColor       (void);
     const Color4f             &getEnvColor       (void) const;
#ifndef OSG_2_PREP
           Color4f             &getEnvColor       (void);
#endif

           GLenum              &editEnvCombineRGB  (void);
     const GLenum              &getEnvCombineRGB  (void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvCombineRGB  (void);
#endif

           GLenum              &editEnvCombineAlpha(void);
     const GLenum              &getEnvCombineAlpha(void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvCombineAlpha(void);
#endif

           Real32              &editEnvScaleRGB    (void);
     const Real32              &getEnvScaleRGB    (void) const;
#ifndef OSG_2_PREP
           Real32              &getEnvScaleRGB    (void);
#endif

           Real32              &editEnvScaleAlpha  (void);
     const Real32              &getEnvScaleAlpha  (void) const;
#ifndef OSG_2_PREP
           Real32              &getEnvScaleAlpha  (void);
#endif

           GLenum              &editEnvSource0RGB  (void);
     const GLenum              &getEnvSource0RGB  (void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvSource0RGB  (void);
#endif

           GLenum              &editEnvSource1RGB  (void);
     const GLenum              &getEnvSource1RGB  (void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvSource1RGB  (void);
#endif

           GLenum              &editEnvSource2RGB  (void);
     const GLenum              &getEnvSource2RGB  (void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvSource2RGB  (void);
#endif

           GLenum              &editEnvSource0Alpha(void);
     const GLenum              &getEnvSource0Alpha(void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvSource0Alpha(void);
#endif

           GLenum              &editEnvSource1Alpha(void);
     const GLenum              &getEnvSource1Alpha(void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvSource1Alpha(void);
#endif

           GLenum              &editEnvSource2Alpha(void);
     const GLenum              &getEnvSource2Alpha(void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvSource2Alpha(void);
#endif

           GLenum              &editEnvOperand0RGB (void);
     const GLenum              &getEnvOperand0RGB (void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvOperand0RGB (void);
#endif

           GLenum              &editEnvOperand1RGB (void);
     const GLenum              &getEnvOperand1RGB (void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvOperand1RGB (void);
#endif

           GLenum              &editEnvOperand2RGB (void);
     const GLenum              &getEnvOperand2RGB (void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvOperand2RGB (void);
#endif

           GLenum              &editEnvOperand0Alpha(void);
     const GLenum              &getEnvOperand0Alpha(void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvOperand0Alpha(void);
#endif

           GLenum              &editEnvOperand1Alpha(void);
     const GLenum              &getEnvOperand1Alpha(void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvOperand1Alpha(void);
#endif

           GLenum              &editEnvOperand2Alpha(void);
     const GLenum              &getEnvOperand2Alpha(void) const;
#ifndef OSG_2_PREP
           GLenum              &getEnvOperand2Alpha(void);
#endif

           GLenum              &editGLId           (void);
     const GLenum              &getGLId           (void) const;
#ifndef OSG_2_PREP
           GLenum              &getGLId           (void);
#endif

           Int32               &editIgnoreGLForAspect(void);
     const Int32               &getIgnoreGLForAspect(void) const;
#ifndef OSG_2_PREP
           Int32               &getIgnoreGLForAspect(void);
#endif

           bool                &editPointSprite    (void);
     const bool                &getPointSprite    (void) const;
#ifndef OSG_2_PREP
           bool                &getPointSprite    (void);
#endif

           Real32              &editPriority       (void);
     const Real32              &getPriority       (void) const;
#ifndef OSG_2_PREP
           Real32              &getPriority       (void);
#endif

           GLenum              &editShaderOperation(void);
     const GLenum              &getShaderOperation(void) const;
#ifndef OSG_2_PREP
           GLenum              &getShaderOperation(void);
#endif

           GLenum              &editShaderInput    (void);
     const GLenum              &getShaderInput    (void) const;
#ifndef OSG_2_PREP
           GLenum              &getShaderInput    (void);
#endif

           Real32              &editShaderOffsetScale(void);
     const Real32              &getShaderOffsetScale(void) const;
#ifndef OSG_2_PREP
           Real32              &getShaderOffsetScale(void);
#endif

           Real32              &editShaderOffsetBias(void);
     const Real32              &getShaderOffsetBias(void) const;
#ifndef OSG_2_PREP
           Real32              &getShaderOffsetBias(void);
#endif

           GLenum              &editShaderRGBADotProduct(void);
     const GLenum              &getShaderRGBADotProduct(void) const;
#ifndef OSG_2_PREP
           GLenum              &getShaderRGBADotProduct(void);
#endif

           UInt8               &editShaderCullModes(void);
     const UInt8               &getShaderCullModes(void) const;
#ifndef OSG_2_PREP
           UInt8               &getShaderCullModes(void);
#endif

           Vec3f               &editShaderConstEye (void);
     const Vec3f               &getShaderConstEye (void) const;
#ifndef OSG_2_PREP
           Vec3f               &getShaderConstEye (void);
#endif

           Real32              &editLodBias        (void);
     const Real32              &getLodBias        (void) const;
#ifndef OSG_2_PREP
           Real32              &getLodBias        (void);
#endif

           GLenum              &editTarget         (void);
     const GLenum              &getTarget         (void) const;
#ifndef OSG_2_PREP
           GLenum              &getTarget         (void);
#endif

           Int32               &editDirtyLeft      (void);
     const Int32               &getDirtyLeft      (void) const;
#ifndef OSG_2_PREP
           Int32               &getDirtyLeft      (void);
#endif

           Int32               &editDirtyMinX      (void);
     const Int32               &getDirtyMinX      (void) const;
#ifndef OSG_2_PREP
           Int32               &getDirtyMinX      (void);
#endif

           Int32               &editDirtyMaxX      (void);
     const Int32               &getDirtyMaxX      (void) const;
#ifndef OSG_2_PREP
           Int32               &getDirtyMaxX      (void);
#endif

           Int32               &editDirtyMinY      (void);
     const Int32               &getDirtyMinY      (void) const;
#ifndef OSG_2_PREP
           Int32               &getDirtyMinY      (void);
#endif

           Int32               &editDirtyMaxY      (void);
     const Int32               &getDirtyMaxY      (void) const;
#ifndef OSG_2_PREP
           Int32               &getDirtyMaxY      (void);
#endif

           Int32               &editDirtyMinZ      (void);
     const Int32               &getDirtyMinZ      (void) const;
#ifndef OSG_2_PREP
           Int32               &getDirtyMinZ      (void);
#endif

           Int32               &editDirtyMaxZ      (void);
     const Int32               &getDirtyMaxZ      (void) const;
#ifndef OSG_2_PREP
           Int32               &getDirtyMaxZ      (void);
#endif

           Real32              &editAnisotropy     (void);
     const Real32              &getAnisotropy     (void) const;
#ifndef OSG_2_PREP
           Real32              &getAnisotropy     (void);
#endif

           Color4f             &editBorderColor    (void);
     const Color4f             &getBorderColor    (void) const;
#ifndef OSG_2_PREP
           Color4f             &getBorderColor    (void);
#endif

           UInt32              &editBorderWidth    (void);
     const UInt32              &getBorderWidth    (void) const;
#ifndef OSG_2_PREP
           UInt32              &getBorderWidth    (void);
#endif

           UInt32              &editNPOTMatrixScale(void);
     const UInt32              &getNPOTMatrixScale(void) const;
#ifndef OSG_2_PREP
           UInt32              &getNPOTMatrixScale(void);
#endif

           Real32              &editSkipMipMapLevels(void);
     const Real32              &getSkipMipMapLevels(void) const;
#ifndef OSG_2_PREP
           Real32              &getSkipMipMapLevels(void);
#endif

           Real32              &editShaderOffsetMatrix(const UInt32 index);
     const Real32              &getShaderOffsetMatrix(const UInt32 index) const;
#ifndef OSG_2_PREP
           Real32              &getShaderOffsetMatrix(const UInt32 index);
           MFReal32            &getShaderOffsetMatrix(void);
     const MFReal32            &getShaderOffsetMatrix(void) const;
#endif

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                    Field Set                                 */
    /*! \{                                                                 */

     void setImage          ( const ImagePtr &value );
     void setInternalFormat ( const GLenum &value );
     void setExternalFormat ( const GLenum &value );
     void setScale          ( const bool &value );
     void setFrame          ( const UInt32 &value );
     void setMinFilter      ( const GLenum &value );
     void setMagFilter      ( const GLenum &value );
     void setWrapS          ( const GLenum &value );
     void setWrapT          ( const GLenum &value );
     void setWrapR          ( const GLenum &value );
     void setEnvMode        ( const GLenum &value );
     void setEnvColor       ( const Color4f &value );
     void setEnvCombineRGB  ( const GLenum &value );
     void setEnvCombineAlpha( const GLenum &value );
     void setEnvScaleRGB    ( const Real32 &value );
     void setEnvScaleAlpha  ( const Real32 &value );
     void setEnvSource0RGB  ( const GLenum &value );
     void setEnvSource1RGB  ( const GLenum &value );
     void setEnvSource2RGB  ( const GLenum &value );
     void setEnvSource0Alpha( const GLenum &value );
     void setEnvSource1Alpha( const GLenum &value );
     void setEnvSource2Alpha( const GLenum &value );
     void setEnvOperand0RGB ( const GLenum &value );
     void setEnvOperand1RGB ( const GLenum &value );
     void setEnvOperand2RGB ( const GLenum &value );
     void setEnvOperand0Alpha( const GLenum &value );
     void setEnvOperand1Alpha( const GLenum &value );
     void setEnvOperand2Alpha( const GLenum &value );
     void setGLId           ( const GLenum &value );
     void setIgnoreGLForAspect( const Int32 &value );
     void setPointSprite    ( const bool &value );
     void setPriority       ( const Real32 &value );
     void setShaderOperation( const GLenum &value );
     void setShaderInput    ( const GLenum &value );
     void setShaderOffsetScale( const Real32 &value );
     void setShaderOffsetBias( const Real32 &value );
     void setShaderRGBADotProduct( const GLenum &value );
     void setShaderCullModes( const UInt8 &value );
     void setShaderConstEye ( const Vec3f &value );
     void setLodBias        ( const Real32 &value );
     void setTarget         ( const GLenum &value );
     void setDirtyLeft      ( const Int32 &value );
     void setDirtyMinX      ( const Int32 &value );
     void setDirtyMaxX      ( const Int32 &value );
     void setDirtyMinY      ( const Int32 &value );
     void setDirtyMaxY      ( const Int32 &value );
     void setDirtyMinZ      ( const Int32 &value );
     void setDirtyMaxZ      ( const Int32 &value );
     void setAnisotropy     ( const Real32 &value );
     void setBorderColor    ( const Color4f &value );
     void setBorderWidth    ( const UInt32 &value );
     void setNPOTMatrixScale( const UInt32 &value );
     void setSkipMipMapLevels( const Real32 &value );

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                       Sync                                   */
    /*! \{                                                                 */

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Binary Access                              */
    /*! \{                                                                 */

    virtual SizeT  getBinSize (const BitVector         &whichField);
    virtual void   copyToBin  (      BinaryDataHandler &pMem,
                               const BitVector         &whichField);
    virtual void   copyFromBin(      BinaryDataHandler &pMem,
                               const BitVector         &whichField);


    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Construction                               */
    /*! \{                                                                 */

    static  TextureChunkPtr      create          (void); 
    static  TextureChunkPtr      createEmpty     (void); 

    /*! \}                                                                 */

    /*---------------------------------------------------------------------*/
    /*! \name                       Copy                                   */
    /*! \{                                                                 */

    virtual FieldContainerPtr     shallowCopy     (void) const; 

    /*! \}                                                                 */
    /*=========================  PROTECTED  ===============================*/
  protected:

    /*---------------------------------------------------------------------*/
    /*! \name                      Fields                                  */
    /*! \{                                                                 */

    SFImagePtr          _sfImage;
    SFGLenum            _sfInternalFormat;
    SFGLenum            _sfExternalFormat;
    SFBool              _sfScale;
    SFUInt32            _sfFrame;
    SFGLenum            _sfMinFilter;
    SFGLenum            _sfMagFilter;
    SFGLenum            _sfWrapS;
    SFGLenum            _sfWrapT;
    SFGLenum            _sfWrapR;
    SFGLenum            _sfEnvMode;
    SFColor4f           _sfEnvColor;
    SFGLenum            _sfEnvCombineRGB;
    SFGLenum            _sfEnvCombineAlpha;
    SFReal32            _sfEnvScaleRGB;
    SFReal32            _sfEnvScaleAlpha;
    SFGLenum            _sfEnvSource0RGB;
    SFGLenum            _sfEnvSource1RGB;
    SFGLenum            _sfEnvSource2RGB;
    SFGLenum            _sfEnvSource0Alpha;
    SFGLenum            _sfEnvSource1Alpha;
    SFGLenum            _sfEnvSource2Alpha;
    SFGLenum            _sfEnvOperand0RGB;
    SFGLenum            _sfEnvOperand1RGB;
    SFGLenum            _sfEnvOperand2RGB;
    SFGLenum            _sfEnvOperand0Alpha;
    SFGLenum            _sfEnvOperand1Alpha;
    SFGLenum            _sfEnvOperand2Alpha;
    SFGLenum            _sfGLId;
    SFInt32             _sfIgnoreGLForAspect;
    SFBool              _sfPointSprite;
    SFReal32            _sfPriority;
    SFGLenum            _sfShaderOperation;
    SFGLenum            _sfShaderInput;
    MFReal32            _mfShaderOffsetMatrix;
    SFReal32            _sfShaderOffsetScale;
    SFReal32            _sfShaderOffsetBias;
    SFGLenum            _sfShaderRGBADotProduct;
    SFUInt8             _sfShaderCullModes;
    SFVec3f             _sfShaderConstEye;
    SFReal32            _sfLodBias;
    SFGLenum            _sfTarget;
    SFInt32             _sfDirtyLeft;
    SFInt32             _sfDirtyMinX;
    SFInt32             _sfDirtyMaxX;
    SFInt32             _sfDirtyMinY;
    SFInt32             _sfDirtyMaxY;
    SFInt32             _sfDirtyMinZ;
    SFInt32             _sfDirtyMaxZ;
    SFReal32            _sfAnisotropy;
    SFColor4f           _sfBorderColor;
    SFUInt32            _sfBorderWidth;
    SFUInt32            _sfNPOTMatrixScale;
    SFReal32            _sfSkipMipMapLevels;

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Constructors                               */
    /*! \{                                                                 */

    TextureChunkBase(void);
    TextureChunkBase(const TextureChunkBase &source);

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                   Destructors                                */
    /*! \{                                                                 */

    virtual ~TextureChunkBase(void); 

    /*! \}                                                                 */
    /*---------------------------------------------------------------------*/
    /*! \name                       Sync                                   */
    /*! \{                                                                 */

#if !defined(OSG_FIXED_MFIELDSYNC)
    void executeSyncImpl(      TextureChunkBase *pOther,
                         const BitVector         &whichField);

    virtual void   executeSync(      FieldContainer    &other,
                               const BitVector         &whichField);
#else
    void executeSyncImpl(      TextureChunkBase *pOther,
                         const BitVector         &whichField,
                         const SyncInfo          &sInfo     );

    virtual void   executeSync(      FieldContainer    &other,
                               const BitVector         &whichField,
                               const SyncInfo          &sInfo);

    virtual void execBeginEdit     (const BitVector &whichField,
                                          UInt32     uiAspect,
                                          UInt32     uiContainerSize);

            void execBeginEditImpl (const BitVector &whichField,
                                          UInt32     uiAspect,
                                          UInt32     uiContainerSize);

    virtual void onDestroyAspect(UInt32 uiId, UInt32 uiAspect);
#endif

    /*! \}                                                                 */
    /*==========================  PRIVATE  ================================*/
  private:

    friend class FieldContainer;

    static FieldDescription   *_desc[];
    static FieldContainerType  _type;


    // prohibit default functions (move to 'public' if you need one)
    void operator =(const TextureChunkBase &source);
};

//---------------------------------------------------------------------------
//   Exported Types
//---------------------------------------------------------------------------


typedef TextureChunkBase *TextureChunkBaseP;

typedef osgIF<TextureChunkBase::isNodeCore,
              CoredNodePtr<TextureChunk>,
              FieldContainer::attempt_to_create_CoredNodePtr_on_non_NodeCore_FC
              >::_IRet TextureChunkNodePtr;

typedef RefPtr<TextureChunkPtr> TextureChunkRefPtr;

OSG_END_NAMESPACE

#define OSGTEXTURECHUNKBASE_HEADER_CVSID "@(#)$Id: FCBaseTemplate_h.h,v 1.42 2008/06/09 12:26:59 vossg Exp $"

#endif /* _OSGTEXTURECHUNKBASE_H_ */
